#ifndef FITDIALOG_H
#define FITDIALOG_H

#include <qvariant.h>
#include <qwidget.h>

class QButtonGroup;
class QPushButton;
class QLineEdit;
class QComboBox;
	
class fitDialog : public QWidget
{
    Q_OBJECT

public:
    fitDialog( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~fitDialog();

    QPushButton* buttonOk;
	QPushButton* buttonCancel;
	QPushButton* buttonClear;
    QButtonGroup* GroupBox1, *GroupBox2;
	QComboBox* boxCurve;
	QComboBox* boxFunction;
	QComboBox* boxSolver;
	QLineEdit* boxParams;
	QLineEdit* boxFrom;
	QLineEdit* boxTo;
	QLineEdit* boxPoints, *boxTolerance;

public slots:
	void accept();
	void insertFunctionsList(const QStringList& list);
	void clearList();
	void setCurveNames(const QStringList& names);
	void setLimits(const QStringList& limits);

signals:
	void options(const QString&,const QString&,const QStringList&,
				const QStringList&,double,double,int,int,double);
	void clearFunctionsList();
};

#endif // EXPORTDIALOG_H
