#include "genDialog.h"
#include "textDialog.h"
#include "colors.h"

#include <qcheckbox.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qbuttongroup.h>
#include <qmessagebox.h>
#include <qarray.h>
#include <qinputdialog.h>
#include <qfont.h>
#include <qfontdialog.h> 
#include <qregexp.h> 
#include <qvbox.h>

#include <qwt_plot.h>
#include "parser/muParser.h"

#ifndef M_PI
#define M_PI	3.141592653589793238462643 
#endif

static const char* const image0_data[] = { 
"80 80 204 2",
"  	c None",
". 	c #FFFFFF",
"+ 	c #E0E0E0",
"@ 	c #000000",
"# 	c #BBBBBB",
"$ 	c #D8D8D8",
"% 	c #5E5E5E",
"& 	c #797979",
"* 	c #DDDDDD",
"= 	c #8E908E",
"- 	c #707070",
"; 	c #7B7B7B",
"> 	c #F2F2F2",
", 	c #6F6F6F",
"' 	c #151515",
") 	c #E4E4E4",
"! 	c #B9B9B9",
"~ 	c #7F7F7F",
"{ 	c #929292",
"] 	c #717171",
"^ 	c #AFAFAF",
"/ 	c #969696",
"( 	c #959595",
"_ 	c #B1B1B1",
": 	c #737373",
"< 	c #8D8D8D",
"[ 	c #171717",
"} 	c #282828",
"| 	c #262626",
"1 	c #C4C4C4",
"2 	c #EEEEEE",
"3 	c #EBEBEB",
"4 	c #BABABA",
"5 	c #B8B8B8",
"6 	c #D2D2D2",
"7 	c #DCDCDC",
"8 	c #181818",
"9 	c #E6E6E6",
"0 	c #D4D4D4",
"a 	c #C2C2C2",
"b 	c #B4B4B4",
"c 	c #CFCFCF",
"d 	c #999999",
"e 	c #9D9D9D",
"f 	c #D9D9D9",
"g 	c #B0B0B0",
"h 	c #E7E7E7",
"i 	c #8F8F8F",
"j 	c #6A6A6A",
"k 	c #8C8C8C",
"l 	c #ECECEC",
"m 	c #EDEDED",
"n 	c #909090",
"o 	c #F7F7F7",
"p 	c #FCFCFC",
"q 	c #9A9A9A",
"r 	c #A0A0A0",
"s 	c #F6F6F6",
"t 	c #A5A5A5",
"u 	c #EAEAEA",
"v 	c #989898",
"w 	c #8E8E8E",
"x 	c #FEFEFE",
"y 	c #C7C7C7",
"z 	c #BFBFBF",
"A 	c #F8F8F8",
"B 	c #BDBDBD",
"C 	c #CCCCCC",
"D 	c #B5B5B5",
"E 	c #D3D3D3",
"F 	c #CDCDCD",
"G 	c #898989",
"H 	c #F0F0F0",
"I 	c #C8C8C8",
"J 	c #A9A9A9",
"K 	c #D6D6D6",
"L 	c #888888",
"M 	c #C0C0C0",
"N 	c #A3A3A3",
"O 	c #EFEFEF",
"P 	c #C5C5C5",
"Q 	c #767676",
"R 	c #A7A7A7",
"S 	c #C1C1C1",
"T 	c #F5F5F5",
"U 	c #9C9C9C",
"V 	c #9F9F9F",
"W 	c #313131",
"X 	c #030303",
"Y 	c #D0D0D0",
"Z 	c #6E6E6E",
"` 	c #404040",
" .	c #565656",
"..	c #9E9E9E",
"+.	c #FAFAFA",
"@.	c #CACACA",
"#.	c #696969",
"$.	c #838383",
"%.	c #868686",
"&.	c #B2B2B2",
"*.	c #E3E3E3",
"=.	c #535353",
"-.	c #AEAEAE",
";.	c #3C3C3C",
">.	c #F9F9F9",
",.	c #E9E9E9",
"'.	c #E8E8E8",
").	c #8A8A8A",
"!.	c #A1A1A1",
"~.	c #AAAAAA",
"{.	c #BEBEBE",
"].	c #DBDBDB",
"^.	c #E5E5E5",
"/.	c #F4F4F4",
"(.	c #919191",
"_.	c #8B8B8B",
":.	c #B3B3B3",
"<.	c #D5D5D5",
"[.	c #C3C3C3",
"}.	c #F3F3F3",
"|.	c #353535",
"1.	c #A4A4A4",
"2.	c #7E7E7E",
"3.	c #B7B7B7",
"4.	c #C6C6C6",
"5.	c #7C7C7C",
"6.	c #1C1C1C",
"7.	c #CECECE",
"8.	c #2B2B2B",
"9.	c #3A3A3A",
"0.	c #D1D1D1",
"a.	c #CADDDD",
"b.	c #F3FFFF",
"c.	c #E6FFFF",
"d.	c #FF6E6E",
"e.	c #FF0000",
"f.	c #FF7F7F",
"g.	c #FF7272",
"h.	c #FFCDCD",
"i.	c #FF3E3E",
"j.	c #FF1313",
"k.	c #FFD2D2",
"l.	c #FF3C3C",
"m.	c #FFC0C0",
"n.	c #FF6868",
"o.	c #FFADAD",
"p.	c #FF6B6B",
"q.	c #FF9D9D",
"r.	c #FF1919",
"s.	c #FF8D8D",
"t.	c #FFA0A0",
"u.	c #FFEDED",
"v.	c #FFCBCB",
"w.	c #FFC8C8",
"x.	c #FFAFAF",
"y.	c #FF0606",
"z.	c #FF1414",
"A.	c #FFFDFD",
"B.	c #FFE0E0",
"C.	c #FFEEEE",
"D.	c #FF4141",
"E.	c #FF9393",
"F.	c #FF9999",
"G.	c #FF6363",
"H.	c #FFEAEA",
"I.	c #FF1616",
"J.	c #FF2424",
"K.	c #FFC9C9",
"L.	c #FF9A9A",
"M.	c #FF8888",
"N.	c #FFD3D3",
"O.	c #FF2525",
"P.	c #FF0909",
"Q.	c #FFF3F3",
"R.	c #FFECEC",
"S.	c #FFDDDD",
"T.	c #FF1515",
"U.	c #FF9C9C",
"V.	c #FF8A8A",
"W.	c #FF5B5B",
"X.	c #FFD5D5",
"Y.	c #FF1212",
"Z.	c #FF2D2D",
"`.	c #FFE7E7",
" +	c #FF1B1B",
".+	c #FFE1E1",
"++	c #FF4B4B",
"@+	c #FF7777",
"#+	c #FF0B0B",
"$+	c #FF6C6C",
"%+	c #FFA2A2",
"&+	c #FF3131",
"*+	c #FF3B3B",
"=+	c #FF5555",
"-+	c #FF3737",
";+	c #FF8585",
">+	c #FFF7F7",
",+	c #FF6F6F",
"'+	c #FFB7B7",
")+	c #FF8686",
"!+	c #FF7171",
"~+	c #FF6666",
"{+	c #FF5353",
"]+	c #FFF4F4",
". . . . . . . . . . . . . . . . + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . # @ $ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . % @ & . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . * = - ; > . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . , @ @ ' @ @ ) . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . ! . . . . @ ~ . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . @ { . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . ] @ . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . ^ @ / . ( @ _ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . : @ < . . [ @ } . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . | @ 1 . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . 2 @ @ . . . . . . @ . . . . . . . . . . . . . . . . . . 3 4 5 ! 6 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . 7 @ 8 9 0 a b c . . @ . . . . . . . . . . . . . . . . > d e f 9 + g { h . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . i @ @ @ @ @ @ j . . @ . . . . . . . . . . . . . . . 7 k l . . . . . m n $ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . o i p . . . . . . . . q $ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . r 9 . . . . . . . . . . { s . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . f t . . . . . . . . . . . u v . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . w x . . . . . . . . . . . . y 4 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . c z . . . . . . . . . . . . . . v u . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . w . . . . . . . . . . . . . . . A i . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . B C . . . . . . . . . . . . . . . . D E . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . w . . . . . . . . . . . . . . . . . . w . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . a F . . . . . . . . . . . . . . . . . . c 5 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . G . . . . . . . . . . . . . . . . . . . . G . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . H e . . . . . . . . . . . . . . . . . . . . I J . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . b K . . . . . . . . . . . . . . . . . . . . . ^ 0 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . L . . . . . . . . . . . . . . . . . . . . . . s q . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . 0 M . . . . . . . . . . . . . . . . . . . . . . . N h . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . e O . . . . . . . . . . . . . . . . . . . . . . . u e . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . P # . . @ . . . . . . . s v . . . . . . . . . . . . . . . . . . . . . . . . . e ) . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . 3 @ Q . . @ . . . . . . . # 0 . . . . . . . . . . . . . . . . . . . . . . . . . 2 e . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . v @ @ @ 3 . . @ . . . . . . . < . . . . . . . . . . . . . . . . . . . . . . . . . . . R f . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . S @ . . . @ . . . . . . T U . . . . . . . . . . . . . . . . . . . . . . . . . . . 3 V . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . W X . . . @ . . . . . . y y . . . . . . . . . . . . . . . . . . . . . . . . . . . . ^ Y . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . @ Z . . ` @  .. . . . . ..+.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . w . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . @ @.. . #.@ $.. . . . . %.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 1 P . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . &.@ . . . . @ . . . . . *._ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . w +.. . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . =.@ . . . . @ . . . . . S 0 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . f -.. . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . E . @ ;.>.,.. . @ . . . . . _ '.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . e ) . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . 2 @ @ @ @ @ - . . @ . . . . . i . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . o w o . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . ).. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ) !.. . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . x / . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ~.1 . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . c {.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . V ].. . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . 5 ^.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . d * . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . q +.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . n u . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . $.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . /.(.u . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . _.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . s n ^.. . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . s R . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . o q P . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . 2 J . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . :.t >.. . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . <.B . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 7 i y . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . ^.$ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . [._.{.. . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . p P _.~.K }.. . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . * ! 4 . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . 3 |.. . . . . . . . . . . . . . . . . . . . . . . . 1.2.. . . . . . . K . . . ",
". . . . . . . . . . . . . . . . @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ y ",
". . . . . . . . . . . . . . . . 3.[.z z z z z z z z z z z z z z z z z z z z z z 4.5.@ 0 z z z z z z z z z z z z z z z z z z z z z z C ;.6.7.z z z z z @.8.9.0.. ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . a.. . . . . . . . . . . . . . . . . . . . . . . . b.c.. . . . . . . . . . . ",
". . . . . . . . . . . d.e.e.e.f.. . . . . . . . . . . . . . . . . . . . . . . . . . g.f.. . . . . . . . . . . . . . . . . . . . . h.i.e.e.j.k.. . . . . . . . . ",
". . . . . . . . . . l.e.m.. n.e.. . . . . . . . . . . . . . . . . . . . . . . . o.p.e.q.. . . . . . . . . . . . . . . . . . . . . e.r.s.t.e.e.. . . . . . . . . ",
". . . . . . . . . u.e.v.. . . e.w.. . . . . . . . . . . . . . . . . . . . . . x.y.z.e.. . . . . . . . . . . . . . . . . . . . . . A.. . . B.e.C.. . . . . . . . ",
". . . . . . . . . D.e.. . . . e.v.. . . . . . . . . . . . . . . . . . . . . . . . E.e.. . . . . . . . . . . . . . . . . . . . . . . . . . F.e.. . . . . . . . . ",
". . . . . . . . . e.G.. . . C.e.H.. . . . . . . . . . . . . . . . . . . . . . . . I.J.. . . . . . . . . . . . . . . . . . . . . . . . . . e.l.. . . . . . . . . ",
". . . . . . . . . e.K.. . . L.e.. . . . . . . . . . . . . . . . . . . . . . . . . e.M.. . . . . . . . . . . . . . . . . . . . . . . . . e.e.. . . . . . . . . . ",
". . . . . . . . N.e.. . . . O.P.. . . . . . . . . . . . . . . . . . . . . . . . Q.e.R.. . . . . . . . . . . . . . . . . . . . . . . S.e.T.. . . . . . . . . . . ",
". . . . . . . . v.e.. . . . e.U.. . . . . . . . . . . . . . . . . . . . . . . . L.e.. . . . . . . . . . . . . . . . . . . . . . . V.e.W.. . . . . . . . . . . . ",
". . . . . . . . X.e.A.. . l.e.. . . . . . . . . . . . . . . . . . . . . . . . . i.Y.. . . . . . . . . . . . . . . . . . . . . . Z.e.`.. . . . . . . . . . . . . ",
". . . . . . . . . e.e. +e.e..+. . . . . . . . . . . . . . . . . . . . . . . ++@+e.#+$+%+. . . . . . . . . . . . . . . . . . . &+e.*+=+i.-+O.v.. . . . . . . . . ",
". . . . . . . . . . ;+g.s.. . . . . . . . . . . . . . . . . . . . . . . . >+++n.,+,+W.'+. . . . . . . . . . . . . . . . . . . )+,+!+n.~+~+{+]+. . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . "};

static const char* const image1_data[] = { 
"80 80 210 2",
"  	c None",
". 	c #FFFFFF",
"+ 	c #E0E0E0",
"@ 	c #000000",
"# 	c #BBBBBB",
"$ 	c #D8D8D8",
"% 	c #5E5E5E",
"& 	c #797979",
"* 	c #FFDDDD",
"= 	c #FE908E",
"- 	c #FF7070",
"; 	c #FF7B7B",
"> 	c #FFF2F2",
", 	c #FF6F6F",
"' 	c #FF0000",
") 	c #FF1515",
"! 	c #FFE4E4",
"~ 	c #FFB9B9",
"{ 	c #FF7F7F",
"] 	c #FF9292",
"^ 	c #FF7171",
"/ 	c #FFAFAF",
"( 	c #FF9696",
"_ 	c #929595",
": 	c #B1B1B1",
"< 	c #FF7373",
"[ 	c #FF8D8D",
"} 	c #171717",
"| 	c #282828",
"1 	c #FF2626",
"2 	c #FFC4C4",
"3 	c #FFEEEE",
"4 	c #EBEBEB",
"5 	c #BABABA",
"6 	c #B8B8B8",
"7 	c #B9B9B9",
"8 	c #D2D2D2",
"9 	c #FFDCDC",
"0 	c #FF1818",
"a 	c #FFE6E6",
"b 	c #FFD4D4",
"c 	c #FFC2C2",
"d 	c #FFB4B4",
"e 	c #FFCFCF",
"f 	c #F2F2F2",
"g 	c #999999",
"h 	c #9D9D9D",
"i 	c #D9D9D9",
"j 	c #E6E6E6",
"k 	c #B0B0B0",
"l 	c #929292",
"m 	c #E7E7E7",
"n 	c #FF8F8F",
"o 	c #FF6A6A",
"p 	c #DCDCDC",
"q 	c #8C8C8C",
"r 	c #ECECEC",
"s 	c #EDEDED",
"t 	c #909090",
"u 	c #F7F7F7",
"v 	c #8F8F8F",
"w 	c #FCFCFC",
"x 	c #9A9A9A",
"y 	c #A0A0A0",
"z 	c #F6F6F6",
"A 	c #A5A5A5",
"B 	c #EAEAEA",
"C 	c #989898",
"D 	c #8E8E8E",
"E 	c #FEFEFE",
"F 	c #C7C7C7",
"G 	c #CFCFCF",
"H 	c #BFBFBF",
"I 	c #F8F8F8",
"J 	c #BDBDBD",
"K 	c #CCCCCC",
"L 	c #B5B5B5",
"M 	c #D3D3D3",
"N 	c #C2C2C2",
"O 	c #CDCDCD",
"P 	c #898989",
"Q 	c #F0F0F0",
"R 	c #C8C8C8",
"S 	c #A9A9A9",
"T 	c #B4B4B4",
"U 	c #D6D6D6",
"V 	c #AFAFAF",
"W 	c #D4D4D4",
"X 	c #888888",
"Y 	c #C0C0C0",
"Z 	c #A3A3A3",
"` 	c #EFEFEF",
" .	c #FFC5C5",
"..	c #FFBBBB",
"+.	c #E4E4E4",
"@.	c #FFEBEB",
"#.	c #FF7676",
"$.	c #EEEEEE",
"%.	c #FF9898",
"&.	c #8D8D8D",
"*.	c #A7A7A7",
"=.	c #FFC1C1",
"-.	c #F5F5F5",
";.	c #9C9C9C",
">.	c #9F9F9F",
",.	c #FF3131",
"'.	c #FF0303",
").	c #D0D0D0",
"!.	c #FF6E6E",
"~.	c #404040",
"{.	c #565656",
"].	c #9E9E9E",
"^.	c #FAFAFA",
"/.	c #FFCACA",
"(.	c #696969",
"_.	c #838383",
":.	c #868686",
"<.	c #C4C4C4",
"[.	c #C5C5C5",
"}.	c #FFB2B2",
"|.	c #E3E3E3",
"1.	c #FF5353",
"2.	c #C1C1C1",
"3.	c #AEAEAE",
"4.	c #FFD3D3",
"5.	c #FF3C3C",
"6.	c #FFF9F9",
"7.	c #FFE9E9",
"8.	c #E8E8E8",
"9.	c #8A8A8A",
"0.	c #A1A1A1",
"a.	c #969696",
"b.	c #AAAAAA",
"c.	c #BEBEBE",
"d.	c #DBDBDB",
"e.	c #E5E5E5",
"f.	c #DDDDDD",
"g.	c #F4F4F4",
"h.	c #919191",
"i.	c #8B8B8B",
"j.	c #B3B3B3",
"k.	c #F9F9F9",
"l.	c #D5D5D5",
"m.	c #C3C3C3",
"n.	c #F3F3F3",
"o.	c #353535",
"p.	c #A4A4A4",
"q.	c #7E7E7E",
"r.	c #B7B7B7",
"s.	c #C6C6C6",
"t.	c #7C7C7C",
"u.	c #3C3C3C",
"v.	c #1C1C1C",
"w.	c #CECECE",
"x.	c #CACACA",
"y.	c #2B2B2B",
"z.	c #3A3A3A",
"A.	c #D1D1D1",
"B.	c #727272",
"C.	c #7F7F7F",
"D.	c #3E3E3E",
"E.	c #131313",
"F.	c #FFC0C0",
"G.	c #FF6868",
"H.	c #ADADAD",
"I.	c #6B6B6B",
"J.	c #191919",
"K.	c #FFEDED",
"L.	c #FFCBCB",
"M.	c #FFC8C8",
"N.	c #060606",
"O.	c #141414",
"P.	c #FDFDFD",
"Q.	c #FF4141",
"R.	c #939393",
"S.	c #FF6363",
"T.	c #FFEAEA",
"U.	c #161616",
"V.	c #242424",
"W.	c #FFC9C9",
"X.	c #FF9A9A",
"Y.	c #FF2525",
"Z.	c #FF0909",
"`.	c #151515",
" +	c #FF9C9C",
".+	c #5B5B5B",
"++	c #FFD5D5",
"@+	c #FFFDFD",
"#+	c #121212",
"$+	c #2D2D2D",
"%+	c #FF1B1B",
"&+	c #FFE1E1",
"*+	c #4B4B4B",
"=+	c #777777",
"-+	c #0B0B0B",
";+	c #6C6C6C",
">+	c #A2A2A2",
",+	c #313131",
"'+	c #3B3B3B",
")+	c #555555",
"!+	c #373737",
"~+	c #252525",
"{+	c #CBCBCB",
"]+	c #FF8585",
"^+	c #FF7272",
"/+	c #686868",
"(+	c #6F6F6F",
"_+	c #717171",
":+	c #666666",
"<+	c #535353",
". . . . . . . . . . . . . . . . + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . # @ $ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . % @ & . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . * = - ; > . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . , ' ' ) ' ' ! . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . ~ . . . . ' { . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . ' ] . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . ^ ' . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . / ' ( . _ @ : . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . < ' [ . . } @ | . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . 1 ' 2 . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . 3 ' ' . . . . . . @ . . . . . . . . . . . . . . . . . . 4 5 6 7 8 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . 9 ' 0 a b c d e . . @ . . . . . . . . . . . . . . . . f g h i j + k l m . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . n ' ' ' ' ' ' o . . @ . . . . . . . . . . . . . . . p q r . . . . . s t $ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . u v w . . . . . . . . x $ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . y j . . . . . . . . . . l z . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . i A . . . . . . . . . . . B C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . D E . . . . . . . . . . . . F 5 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . G H . . . . . . . . . . . . . . C B . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . D . . . . . . . . . . . . . . . I v . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . J K . . . . . . . . . . . . . . . . L M . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . D . . . . . . . . . . . . . . . . . . D . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . N O . . . . . . . . . . . . . . . . . . G 6 . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . P . . . . . . . . . . . . . . . . . . . . P . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . Q h . . . . . . . . . . . . . . . . . . . . R S . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . T U . . . . . . . . . . . . . . . . . . . . . V W . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . X . . . . . . . . . . . . . . . . . . . . . . z x . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . W Y . . . . . . . . . . . . . . . . . . . . . . . Z m . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . h ` . . . . . . . . . . . . . . . . . . . . . . . B h . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . .  .... . @ . . . . . . . z C . . . . . . . . . . . . . . . . . . . . . . . . . h +.. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . @.' #.. . @ . . . . . . . # W . . . . . . . . . . . . . . . . . . . . . . . . . $.h . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . %.' ' ' @.. . @ . . . . . . . &.. . . . . . . . . . . . . . . . . . . . . . . . . . . *.i . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . =.' . . . @ . . . . . . -.;.. . . . . . . . . . . . . . . . . . . . . . . . . . . 4 >.. . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . ,.'.. . . @ . . . . . . F F . . . . . . . . . . . . . . . . . . . . . . . . . . . . V ).. . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . ' !.. . ~.@ {.. . . . . ].^.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . D . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . ' /.. . (.@ _.. . . . . :.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . <.[.. . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . }.' . . . . @ . . . . . |.: . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . D ^.. . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . 1.' . . . . @ . . . . . 2.W . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . i 3.. . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . 4.. ' 5.6.7.. . @ . . . . . : 8.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . h +.. . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . 3 ' ' ' ' ' - . . @ . . . . . v . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . u D u . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . 9.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +.0.. . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . E a.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . b.<.. . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . G c.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . >.d.. . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . 6 e.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . g f.. . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . x ^.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . t B . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . _.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . g.h.B . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . i.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . z t e.. . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . z *.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . u x [.. . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . $.S . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . j.A k.. . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . l.J . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . p v F . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . e.$ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . m.i.c.. . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . w [.i.b.U n.. . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . f.7 5 . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . @ . . . . . . . . . . . . . . . . . . . . . . . . 4 o.. . . . . . . . . . . . . . . . . . . . . . . . p.q.. . . . . . . U . . . ",
". . . . . . . . . . . . . . . . @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ F ",
". . . . . . . . . . . . . . . . r.m.H H H H H H H H H H H H H H H H H H H H H H s.t.@ W H H H H H H H H H H H H H H H H H H H H H H K u.v.w.H H H H H x.y.z.A.. ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . f.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . !.' ' ' { . . . . . . . . . . . . . . . . . . . . . . . . . . B.C.. . . . . . . . . . . . . . . . . . . . . O D.@ @ E.8 . . . . . . . . . ",
". . . . . . . . . . 5.' F.. G.' . . . . . . . . . . . . . . . . . . . . . . . . H.I.@ h . . . . . . . . . . . . . . . . . . . . . @ J.&.y @ @ . . . . . . . . . ",
". . . . . . . . . K.' L.. . . ' M.. . . . . . . . . . . . . . . . . . . . . . V N.O.@ . . . . . . . . . . . . . . . . . . . . . . P.. . . + @ $.. . . . . . . . ",
". . . . . . . . . Q.' . . . . ' L.. . . . . . . . . . . . . . . . . . . . . . . . R.@ . . . . . . . . . . . . . . . . . . . . . . . . . . g @ . . . . . . . . . ",
". . . . . . . . . ' S.. . . 3 ' T.. . . . . . . . . . . . . . . . . . . . . . . . U.V.. . . . . . . . . . . . . . . . . . . . . . . . . . @ u.. . . . . . . . . ",
". . . . . . . . . ' W.. . . X.' . . . . . . . . . . . . . . . . . . . . . . . . . @ X . . . . . . . . . . . . . . . . . . . . . . . . . @ @ . . . . . . . . . . ",
". . . . . . . . 4.' . . . . Y.Z.. . . . . . . . . . . . . . . . . . . . . . . . n.@ r . . . . . . . . . . . . . . . . . . . . . . . f.@ `.. . . . . . . . . . . ",
". . . . . . . . L.' . . . . '  +. . . . . . . . . . . . . . . . . . . . . . . . x @ . . . . . . . . . . . . . . . . . . . . . . . 9.@ .+. . . . . . . . . . . . ",
". . . . . . . . ++' @+. . 5.' . . . . . . . . . . . . . . . . . . . . . . . . . D.#+. . . . . . . . . . . . . . . . . . . . . . $+@ m . . . . . . . . . . . . . ",
". . . . . . . . . ' ' %+' ' &+. . . . . . . . . . . . . . . . . . . . . . . *+=+@ -+;+>+. . . . . . . . . . . . . . . . . . . ,+@ '+)+D.!+~+{+. . . . . . . . . ",
". . . . . . . . . . ]+^+[ . . . . . . . . . . . . . . . . . . . . . . . . u *+/+(+(+.+r.. . . . . . . . . . . . . . . . . . . :.(+_+/+:+:+<+g.. . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . "};


static const char* const image2_data[] = { 
"74 77 171 2",
"  	c None",
". 	c #FFFFFF",
"+ 	c #E0E0E0",
"@ 	c #FAFAFA",
"# 	c #363636",
"$ 	c #ABABAB",
"% 	c #000000",
"& 	c #BDBDBD",
"* 	c #737373",
"= 	c #858585",
"- 	c #FFE8E8",
"; 	c #FFF7F7",
"> 	c #FFD1D1",
", 	c #FFF0F0",
"' 	c #E6E6E6",
") 	c #FFB2B2",
"! 	c #FFE6E6",
"~ 	c #FF6666",
"{ 	c #FFCCCC",
"] 	c #C9C9C9",
"^ 	c #939493",
"/ 	c #808080",
"( 	c #878787",
"_ 	c #D6D6D6",
": 	c #969696",
"< 	c #030303",
"[ 	c #383838",
"} 	c #4C4C4C",
"| 	c #1A1A1A",
"1 	c #080808",
"2 	c #C2C2C2",
"3 	c #EBEBEB",
"4 	c #F0F0F0",
"5 	c #8C8C8C",
"6 	c #7A7A7A",
"7 	c #A3A3A3",
"8 	c #999999",
"9 	c #A1A1A1",
"0 	c #828282",
"a 	c #949494",
"b 	c #F2F2F2",
"c 	c #474747",
"d 	c #545454",
"e 	c #0F0F0F",
"f 	c #B5B5B5",
"g 	c #CFCFCF",
"h 	c #262626",
"i 	c #333333",
"j 	c #DEDEDE",
"k 	c #FDFDFD",
"l 	c #D7D7D7",
"m 	c #B7B7B7",
"n 	c #C4C4C4",
"o 	c #F7F7F7",
"p 	c #CCCCCC",
"q 	c #2E2E2E",
"r 	c #B2B2B2",
"s 	c #DFDFDF",
"t 	c #ACACAC",
"u 	c #ADADAD",
"v 	c #D3D3D3",
"w 	c #CDCDCD",
"x 	c #AAAAAA",
"y 	c #D4C3C3",
"z 	c #A9A9A9",
"A 	c #AAA8A8",
"B 	c #DB7F7F",
"C 	c #E3E3E3",
"D 	c #E5E5E5",
"E 	c #F2DADA",
"F 	c #B19999",
"G 	c #FFC4C4",
"H 	c #D2D2D2",
"I 	c #FFD4D4",
"J 	c #EA6565",
"K 	c #E2E2E2",
"L 	c #FFA1A1",
"M 	c #C8C8C8",
"N 	c #AFAFAF",
"O 	c #FF9999",
"P 	c #F5C6C6",
"Q 	c #E9E9E9",
"R 	c #B6B6B6",
"S 	c #CFB4B4",
"T 	c #B9B9B9",
"U 	c #F5F5F5",
"V 	c #ACA7A7",
"W 	c #EAEAEA",
"X 	c #F9F9F9",
"Y 	c #B8B8B8",
"Z 	c #C0A6A6",
"` 	c #B4B4B4",
" .	c #EFEFEF",
"..	c #F2C3C3",
"+.	c #EEEEEE",
"@.	c #BCBCBC",
"#.	c #C5C5C5",
"$.	c #DADADA",
"%.	c #BEBEBE",
"&.	c #B0B0B0",
"*.	c #FBFBFB",
"=.	c #C6C6C6",
"-.	c #B1B1B1",
";.	c #BABABA",
">.	c #AEAEAE",
",.	c #D0D0D0",
"'.	c #FCFCFC",
").	c #141414",
"!.	c #D8D8D8",
"~.	c #C7C7C7",
"{.	c #575757",
"].	c #3D3D3D",
"^.	c #C3C3C3",
"/.	c #5E5E5E",
"(.	c #7D7D7D",
"_.	c #B3B3B3",
":.	c #F6C8C8",
"<.	c #757575",
"[.	c #919191",
"}.	c #CAB3B3",
"|.	c #EDEDED",
"1.	c #ADA8A8",
"2.	c #666666",
"3.	c #2B2B2B",
"4.	c #BBBBBB",
"5.	c #C9AAAA",
"6.	c #292929",
"7.	c #D4D4D4",
"8.	c #FBC9C9",
"9.	c #E8E8E8",
"0.	c #9C9C9C",
"a.	c #E4E4E4",
"b.	c #E7E7E7",
"c.	c #CACACA",
"d.	c #C1C1C1",
"e.	c #E39090",
"f.	c #CBCBCB",
"g.	c #ADA3A3",
"h.	c #C8B0B0",
"i.	c #F59A9A",
"j.	c #C0A9A9",
"k.	c #C9BFBF",
"l.	c #7A4747",
"m.	c #A18C8C",
"n.	c #8C8282",
"o.	c #332929",
"p.	c #242424",
"q.	c #0A0A0A",
"r.	c #454545",
"s.	c #595959",
"t.	c #525252",
"u.	c #5C5C5C",
"v.	c #D9D9D9",
"w.	c #121212",
"x.	c #8A8A8A",
"y.	c #171717",
"z.	c #A8A8A8",
"A.	c #696969",
"B.	c #707070",
"C.	c #9E9E9E",
"D.	c #404040",
"E.	c #616161",
"F.	c #8F8F8F",
"G.	c #4F4F4F",
"H.	c #050505",
"I.	c #DBDBDB",
"J.	c #4A4A4A",
"K.	c #212121",
"L.	c #3B3B3B",
"M.	c #636363",
"N.	c #D1D1D1",
". . . . . . . . . . + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . @ # . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . $ % & . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . * % = . . . . . . . . . . . - . . . . . . . . . . . ; > . . . . . . . . . . . . , . . . . . . . . . . . - - . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . ] ^ / ( _ . ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . : < [ } | 1 ] ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . 2 ' . . 3 % / ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . . . . 4 % 5 ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . . . . 6 1 + ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . . . 7 < 8 @ 5 % 9 . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . . 0 < a . b c % d . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . b d e f . . . ' % . . . . . . . . . . . . ) . . . . . . . . . . . ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". g h i j . . . . ' % . . . . . . . . . . . . ) . . . . k l m m m n o ! ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
"p 1 q $ r r r g . ' % . . . . . . . . . . . . ) . . . s t u ] v w r x y ~ . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
"7 i i i i i i : . ' % . . . . . . . . . . . . ) . . p z _ . . . . . l A B . . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . ) . C x D . . . . . . . E F ] . . . . . . . . . . . { . . . . . . . . . . . ) ) . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . G . u H . . . . . . . . I J x K . . . . . . . . . . { . . . . . . . . . . . L G . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { M N . . . . . . . . . { ~ _ $ o . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . P x Q . . . . . . . . . { ~ . & R . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . S T . . . . . . . . . . { ~ . U $ _ . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . 4 V W . . . . . . . . . . { ~ . . K x X . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . Y Z . . . . . . . . . . . { ~ . . . ` n . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . .  .x ... . . . . . . . . . . { ~ . . . +.$ +.. . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . @.n { . . . . . . . . . . . { ~ . . . . #.R . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . x +.{ . . . . . . . . . . . { ~ . . . . X z o . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . $.u . { . . . . . . . . . . . { ~ . . . . . %.&.*.. . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . ` =.. { . . . . . . . . . . . { ~ . . . . . . -.=.. . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . 4 z X . { . . . . . . . . . . . { ~ . . . . . . + t . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . #.;.. . { . . . . . . . . . . . { ~ . . . . . . . >.v . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . u $.. . { . . . . . . . . . . . { ~ . . . . . . . _ t . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . n 2 . ' % . . . . . . . + t k . . { . . . . . . . . . . . { ~ . . . . . . . . t ,.. . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . '.& ).5 . ' % . . . . . . . m #.. . . { . . . . . . . . . . . { ~ . . . . . . . . !.t . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . f % % % ~.. ' % . . . . . . . x W . . . { . . . . . . . . . . . { ~ . . . . . . . . . N ] . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . a 1 @ . ' % . . . . . . s u . . . . { . . . . . . . . . . . { ~ . . . . . . . . . l u k { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . {.].. . ' % . . . . . . %.%.. . . . { . . . . . . . . . . . { ~ . . . . . . . . . . r ^.{ . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . | 6 . U /.% (.. . . . . _.' . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . 4 u :.. . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . + % r . o <.% [.. . . . o $ '.. . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . ^.}.. . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . 7 % |.. . ' % . . . . . ,._.. . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . o 1.D . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . 2.3.. . . ' % . . . . . 4.=.. . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . 5.-.. . . . . . . . . . O { . . . . . . . . . . . ",
". . p p 6.} p + . ' % . . . . . _.7.. . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . 8.t ,.. . . . . . . . . O { . . . . . . . . . . . ",
". 9.i i i i i 0.. ' % . . . . . x +.. . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { C x a.. . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . x . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . ,.u . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . b.t . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . &.4.. . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . ^.T . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . X u c.. . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . m H . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . +.$ p . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . t C . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . +.x _ . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . z X . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . + x _ . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . U x . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . K x H . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . a.f . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . ' &.d.X O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . $.-.. . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . X _.>.e.{ . . . . . . . . . . . ",
". . . . . . . . . ' % . . . M 4.. . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . f.g.h.U . . . . . . . . . . ",
". . . . . . . . . ' % . . . $.,.. . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . i.j.x Y b . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { b.@.x &.~.D . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { . . U f.m @.. . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . { ~ . . . . . . . . . . . . { . . . . . . . . . . . O { . . . . . . . . . . . ",
". . . . . . . . . ' % . . . . . . . . . . . . { . . . . . . . . . . . k.l.. . . . . . . . . . . . { . . . . . . . . . . . m.n.. . . . . . . 2 C . . ",
". . . . . . . . . ' % i i i i i i i i i i i i o.i i i i i i i i i i i p.q.i i i i i i i i i i i i o.i i i i i i i i i i i | ).i i i i i i i ).< r.~.",
". . . . . . . . . . Y r r r r r r r r r r r r r r r r r r r r r r r r (.p.r r r r r r r r r r r r r r r r r r r r r r r r s.c r r r r r r r t.u.2 . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 4 ] . . . . . . . . . . . . . . . . . . . . . . . . + v.. . . . . . . . . . . ",
". . . . '.= ).% w.[.. . . . . . . . . . . . . . . . . . . . . . . . . . x.8 . . . . . . . . . . . . . . . . . . . . . ~.2.[ i c 2 . . . . . . . . . ",
". . . . 2.y.z.p A.< j . . . . . . . . . . . . . . . . . . . . . . b &.B.< C.. . . . . . . . . . . . . . . . . . . . . D.t.[.a 3.1 9.. . . . . . . . ",
". . . p % &.. . + % r . . . . . . . . . . . . . . . . . . . . . . 2 } i % v.. . . . . . . . . . . . . . . . . . . . . 3 . . . &.% p . . . . . . . . ",
". . . E.h . . . ' % r . . . . . . . . . . . . . . . . . . . . . . . . / ).. . . . . . . . . . . . . . . . . . . . . . . . . . F.< 9.. . . . . . . . ",
". . . | * . . . ~.% ~.. . . . . . . . . . . . . . . . . . . . . . . . c G.. . . . . . . . . . . . . . . . . . . . . . . . . + ).E.. . . . . . . . . ",
". . j % &.. . . a H.U . . . . . . . . . . . . . . . . . . . . . . . '.q.x.. . . . . . . . . . . . . . . . . . . . . . . . j h # U . . . . . . . . . ",
". . Y % I.. . . G.D.. . . . . . . . . . . . . . . . . . . . . . . . p % ~.. . . . . . . . . . . . . . . . . . . . . . . n y.J.4 . . . . . . . . . . ",
". . r % ' . . 9.1 8 . . . . . . . . . . . . . . . . . . . . . . . . a 1 o . . . . . . . . . . . . . . . . . . . . . . [.H.<.'.. . . . . . . . . . . ",
". . & % 2 . '.s.K.U . . . . . . . . . . . . . . . . . . . . . . . . d L.. . . . . . . . . . . . . . . . . . . . . |.t.w.r . . . . . . . . . . . . . ",
". . @ 6.).} h y.p . . . . . . . . . . . . . . . . . . . . . . @ / / ).# / Y . . . . . . . . . . . . . . . . . . . M.% J.2.2.2.2.N.. . . . . . . . . ",
". . . 3 F./ a 4 . . . . . . . . . . . . . . . . . . . . . . . |./ / / / / n . . . . . . . . . . . . . . . . . . . 0./ / / / / / 9.. . . . . . . . . "};

static const char* const image3_data[] = { 
"74 77 168 2",
"  	c None",
". 	c #FFFFFF",
"+ 	c #E0E0E0",
"@ 	c #FAFAFA",
"# 	c #363636",
"$ 	c #ABABAB",
"% 	c #000000",
"& 	c #BDBDBD",
"* 	c #737373",
"= 	c #858585",
"- 	c #E6E6E6",
"; 	c #C9C9C9",
"> 	c #939493",
", 	c #808080",
"' 	c #878787",
") 	c #D6D6D6",
"! 	c #969696",
"~ 	c #030303",
"{ 	c #383838",
"] 	c #4C4C4C",
"^ 	c #1A1A1A",
"/ 	c #080808",
"( 	c #C2C2C2",
"_ 	c #EBEBEB",
": 	c #F0F0F0",
"< 	c #8C8C8C",
"[ 	c #7A7A7A",
"} 	c #A3A3A3",
"| 	c #999999",
"1 	c #A1A1A1",
"2 	c #FFE6E6",
"3 	c #FFF0F0",
"4 	c #828282",
"5 	c #949494",
"6 	c #F2F2F2",
"7 	c #474747",
"8 	c #545454",
"9 	c #FF8080",
"0 	c #FFB2B2",
"a 	c #0F0F0F",
"b 	c #B5B5B5",
"c 	c #CFCFCF",
"d 	c #262626",
"e 	c #333333",
"f 	c #DEDEDE",
"g 	c #FDFDFD",
"h 	c #D7D7D7",
"i 	c #B7B7B7",
"j 	c #C4C4C4",
"k 	c #F7F7F7",
"l 	c #CCCCCC",
"m 	c #2E2E2E",
"n 	c #B2B2B2",
"o 	c #DFDFDF",
"p 	c #ACACAC",
"q 	c #ADADAD",
"r 	c #D3D3D3",
"s 	c #CDCDCD",
"t 	c #AAAAAA",
"u 	c #D4D4D4",
"v 	c #A9A9A9",
"w 	c #DBDBDB",
"x 	c #E3E3E3",
"y 	c #E5E5E5",
"z 	c #B1B1B1",
"A 	c #D2D2D2",
"B 	c #EAEAEA",
"C 	c #E2E2E2",
"D 	c #C8C8C8",
"E 	c #AFAFAF",
"F 	c #F5F5F5",
"G 	c #E9E9E9",
"H 	c #B6B6B6",
"I 	c #B9B9B9",
"J 	c #F9F9F9",
"K 	c #B8B8B8",
"L 	c #C0C0C0",
"M 	c #B4B4B4",
"N 	c #EFD9D9",
"O 	c #AAA8A8",
"P 	c #F2DBDB",
"Q 	c #EED6D6",
"R 	c #ABA8A8",
"S 	c #EED8D8",
"T 	c #BCB1B1",
"U 	c #C4B6B6",
"V 	c #C5B7B7",
"W 	c #B6ADAD",
"X 	c #EEEEEE",
"Y 	c #DADADA",
"Z 	c #BEBEBE",
"` 	c #B0B0B0",
" .	c #FBFBFB",
"..	c #C6C6C6",
"+.	c #C5C5C5",
"@.	c #BABABA",
"#.	c #AEAEAE",
"$.	c #D0D0D0",
"%.	c #FCFCFC",
"&.	c #141414",
"*.	c #D8D8D8",
"=.	c #C7C7C7",
"-.	c #575757",
";.	c #3D3D3D",
">.	c #C3C3C3",
",.	c #5E5E5E",
"'.	c #7D6E6E",
").	c #FF9999",
"!.	c #B39D9D",
"~.	c #E69292",
"{.	c #F09393",
"].	c #ADA2A2",
"^.	c #F49999",
"/.	c #FFC2C2",
"(.	c #757575",
"_.	c #918787",
":.	c #F7AEAE",
"<.	c #ABA6A6",
"[.	c #FCB2B2",
"}.	c #C3A0A0",
"|.	c #C7A4A4",
"1.	c #FFD1D1",
"2.	c #EDEDED",
"3.	c #B3B3B3",
"4.	c #666666",
"5.	c #2B2B2B",
"6.	c #BBBBBB",
"7.	c #292929",
"8.	c #E8E8E8",
"9.	c #9C9C9C",
"0.	c #E4E4E4",
"a.	c #E7E7E7",
"b.	c #CACACA",
"c.	c #E4A7A7",
"d.	c #B59F9F",
"e.	c #E6A7A7",
"f.	c #B0A3A3",
"g.	c #C19E9E",
"h.	c #F9B0B0",
"i.	c #CBCBCB",
"j.	c #F4F4F4",
"k.	c #BCBCBC",
"l.	c #707070",
"m.	c #242424",
"n.	c #0A0A0A",
"o.	c #454545",
"p.	c #7D7D7D",
"q.	c #595959",
"r.	c #525252",
"s.	c #5C5C5C",
"t.	c #D9D9D9",
"u.	c #121212",
"v.	c #919191",
"w.	c #8A8A8A",
"x.	c #171717",
"y.	c #A8A8A8",
"z.	c #696969",
"A.	c #9E9E9E",
"B.	c #404040",
"C.	c #616161",
"D.	c #8F8F8F",
"E.	c #4F4F4F",
"F.	c #050505",
"G.	c #4A4A4A",
"H.	c #212121",
"I.	c #3B3B3B",
"J.	c #636363",
"K.	c #D1D1D1",
". . . . . . . . . . + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . @ # . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . $ % & . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . * % = . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . ; > , ' ) . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . ! ~ { ] ^ / ; - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . ( - . . _ % , - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . : % < - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . [ / + - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . } ~ | @ < % 1 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 3 . . . ",
". . . . 4 ~ 5 . 6 7 % 8 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 9 0 . . . ",
". . 6 8 a b . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". c d e f . . . . - % . . . . . . . . . . . . . . . . . g h i i i j k . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
"l / m $ n n n c . - % . . . . . . . . . . . . . . . . o p q ; r s n t u . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
"} e e e e e e ! . - % . . . . . . . . . . . . . . . l v ) . . . . . h t w . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . x t y . . . . . . . 6 z ; . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . q A . . . . . . . . . B t C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . D E . . . . . . . . . . . ) $ k . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . F t G . . . . . . . . . . . . & H . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . c I . . . . . . . . . . . . . F $ ) . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . : p B . . . . . . . . . . . . . . C t J . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . K L . . . . . . . . . . . . . . . . M j . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % 2 2 2 2 2 2 2 2 2 2 N O P 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 Q R S 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 3 . . . ",
". . . . . . . . . - % 2 2 2 2 2 2 2 2 2 2 T U 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 V W 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 3 . . . ",
". . . . . . . . . - % . . . . . . . . . . t X . . . . . . . . . . . . . . . . . . J v k . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . Y q . . . . . . . . . . . . . . . . . . . . Z `  .. . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . M ... . . . . . . . . . . . . . . . . . . . . z ... . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . : v J . . . . . . . . . . . . . . . . . . . . . + p . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . +.@.. . . . . . . . . . . . . . . . . . . . . . . #.r . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . q Y . . . . . . . . . . . . . . . . . . . . . . . ) p . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . j ( . - % . . . . . . . + p g . . . . . . . . . . . . . . . . . . . . . . . . p $.. . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . %.& &.< . - % . . . . . . . i +.. . . . . . . . . . . . . . . . . . . . . . . . . *.p . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . b % % % =.. - % . . . . . . . t B . . . . . . . . . . . . . . . . . . . . . . . . . . E ; . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . 5 / @ . - % . . . . . . o q . . . . . . . . . . . . . . . . . . . . . . . . . . . h q g . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . -.;.. . - % . . . . . . Z Z . . . . . . . . . . . . . . . . . . . . . . . . . . . . n >.. . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . ^ [ . F ,.% '.).).).).).!.~.).).).).).).).).).).).).).).).).).).).).).).).).).).).).{.].^.).).).).).).).).).).).).).).).).).).).)./.. . . ",
". . . . + % n . k (.% _.0 0 0 0 :.<.[.0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 }.|.0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1.. . . ",
". . . . } % 2.. . - % . . . . . $.3.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . k p y . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . 4.5.. . . - % . . . . . 6.... . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ; z . . . . . . . . . . . . . . . . . . . . . . . ",
". . l l 7.] l + . - % . . . . . 3.u . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .  .p $.. . . . . . . . . . . . . . . . . . . . . . ",
". 8.e e e e e 9.. - % . . . . . t X . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . x t 0.. . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . t . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . $.q . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . a.p . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ` 6.. . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . >.I . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . J q b.. . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . i A . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . X $ l . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . p x . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . X t ) . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . v J . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . + t ) . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . F t . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . C t A . . . . . . . . . . . . . . . ",
". . . . . . . . . - % 0 0 0 c.d.0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 e.f.g.h.0 0 0 0 0 0 0 0 0 1.. . . ",
". . . . . . . . . - % . . . Y z . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . J 3.#.x . . . . . . . . . . . . ",
". . . . . . . . . - % . . . D 6.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . i.p D F . . . . . . . . . . ",
". . . . . . . . . - % . . . Y $.. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . j.L t K 6 . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . a.k.t ` =.y . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . F i.i k.. . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . - % . . . . . . . . . . . . . . . . . . . . . . . . ; l.. . . . . . . . . . . . . . . . . . . . . . . . 1 < . . . . . . . ( x . . ",
". . . . . . . . . - % e e e e e e e e e e e e e e e e e e e e e e e e m.n.e e e e e e e e e e e e e e e e e e e e e e e e ^ &.e e e e e e e &.~ o.=.",
". . . . . . . . . . K n n n n n n n n n n n n n n n n n n n n n n n n p.m.n n n n n n n n n n n n n n n n n n n n n n n n q.7 n n n n n n n r.s.( . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . : ; . . . . . . . . . . . . . . . . . . . . . . . . + t.. . . . . . . . . . . ",
". . . . %.= &.% u.v.. . . . . . . . . . . . . . . . . . . . . . . . . . w.| . . . . . . . . . . . . . . . . . . . . . =.4.{ e 7 ( . . . . . . . . . ",
". . . . 4.x.y.l z.~ f . . . . . . . . . . . . . . . . . . . . . . 6 ` l.~ A.. . . . . . . . . . . . . . . . . . . . . B.r.v.5 5./ 8.. . . . . . . . ",
". . . l % ` . . + % n . . . . . . . . . . . . . . . . . . . . . . ( ] e % t.. . . . . . . . . . . . . . . . . . . . . _ . . . ` % l . . . . . . . . ",
". . . C.d . . . - % n . . . . . . . . . . . . . . . . . . . . . . . . , &.. . . . . . . . . . . . . . . . . . . . . . . . . . D.~ 8.. . . . . . . . ",
". . . ^ * . . . =.% =.. . . . . . . . . . . . . . . . . . . . . . . . 7 E.. . . . . . . . . . . . . . . . . . . . . . . . . + &.C.. . . . . . . . . ",
". . f % ` . . . 5 F.F . . . . . . . . . . . . . . . . . . . . . . . %.n.w.. . . . . . . . . . . . . . . . . . . . . . . . f d # F . . . . . . . . . ",
". . K % w . . . E.B.. . . . . . . . . . . . . . . . . . . . . . . . l % =.. . . . . . . . . . . . . . . . . . . . . . . j x.G.: . . . . . . . . . . ",
". . n % - . . 8./ | . . . . . . . . . . . . . . . . . . . . . . . . 5 / k . . . . . . . . . . . . . . . . . . . . . . v.F.(.%.. . . . . . . . . . . ",
". . & % ( . %.q.H.F . . . . . . . . . . . . . . . . . . . . . . . . 8 I.. . . . . . . . . . . . . . . . . . . . . 2.r.u.n . . . . . . . . . . . . . ",
". . @ 7.&.] d x.l . . . . . . . . . . . . . . . . . . . . . . @ , , &.# , K . . . . . . . . . . . . . . . . . . . J.% G.4.4.4.4.K.. . . . . . . . . ",
". . . _ D., 5 : . . . . . . . . . . . . . . . . . . . . . . . 2., , , , , j . . . . . . . . . . . . . . . . . . . 9., , , , , , 8.. . . . . . . . . "};

static const char* const image4_data[] = { 
"36 43 4 1",
"# c #000000",
"a c #bfbfbf",
"b c #ff0000",
". c #ffffff",
"....................................",
".........#.....#.....#.....#........",
".....#.#.#.#.#.#.#.#.#.#.#.#........",
".....#.#.#.#.#.#.#.#.#.#.#.#........",
"....##########################......",
"....#aaaaaaaaaaaaaaaaaaaaaaaa#......",
"..###aaaaaaaaaaaaaaaaaaaaaaaa###....",
"....#aaaaaaaaaaaaaaaaaaaaaaaa#......",
"..###aaaaaaaaaaaaaaaaaaaaaaaa###....",
"....#aaaaaaaaaaaaaaaaaaaaaaaa#......",
".####aaaaaaaaaaaaaaaa#aaaaaaa####...",
"....#aaaaaaaaaaaaaaa#a#aaaaaa#......",
"..###aaaaaaaaaaaaaaa#a#aaaaaa###....",
"....#aaaaaaaaaaaaaa#aaa#aaaaa#......",
"..###aaaaaaa#aaaaaa#aaa#aaaaa###....",
"....#aaaaaa#a#aaaa#aaaaa#aaaa#......",
".####aaaaaa#a#aaaa#aaaaa#aaaa####...",
"....#aaaaa#aaa#aa#aaaaaaa#aaa#......",
"..###aaaaa#aaa###aaaaaaaaa######....",
"....#aaaa#aaaaa#aaaaaaaaaaaaa#......",
"..###aaaa#aaaaa#aaaaaaaaaaaaa###....",
"....#aaa#aaaaaaa#aaaaaaaaaaaa#......",
".#######aaaaaaaaa#####aaaaaaa####...",
"....#aaaaaaaaaaaaaaaaaaaaaaaa#......",
"..###aaaaaaaaaaaaaaaaaaaaaaaa###....",
"....#aaaaaaaaaaaaaaaaaaaaaaaa#......",
"....bbbbbbbbbbbbbbbbbbbbbbbbbb......",
"....bbbbbbbbbbbbbbbbbbbbbbbbbb......",
".....b.b.b.b.b.b.b.b.b.b.b.b........",
".....b.b.b.b.b.b.b.b.b.b.b.b........",
".........b.....b.....b.....b........",
"....................................",
"....................................",
"....................................",
"...####.............................",
"...#...#........#..#................",
"...#...#........#..#................",
"...#...#...###..##.##..###..###.##..",
"...####...#...#.#..#..#...#.#..#..#.",
"...#...#..#...#.#..#..#...#.#..#..#.",
"...#...#..#...#.#..#..#...#.#..#..#.",
"...#...#..#...#.#..#..#...#.#..#..#.",
"...####....###...#..#..###..#..#..#."};

static const char* const image5_data[] = { 
"33 43 4 1",
"# c #000000",
"b c #bfbfbf",
"a c #ff0000",
". c #ffffff",
".................................",
".........#.....#.....#.....#.....",
".....#.#.#.#.#.#.#.#.#.#.#.#.....",
".....#.#.#.#.#.#.#.#.#.#.#.#.....",
"....aa########################...",
"....aabbbbbbbbbbbbbbbbbbbbbbb#...",
"..aaaabbbbbbbbbbbbbbbbbbbbbbb###.",
"....aabbbbbbbbbbbbbbbbbbbbbbb#...",
"..aaaabbbbbbbbbbbbbbbbbbbbbbb###.",
"....aabbbbbbbbbbbbbbbbbbbbbbb#...",
".aaaaabbbbbbbbbbbbbbb#bbbbbbb####",
"....aabbbbbbbbbbbbbb#b#bbbbbb#...",
"..aaaabbbbbbbbbbbbbb#b#bbbbbb###.",
"....aabbbbbbbbbbbbb#bbb#bbbbb#...",
"..aaaabbbbbb#bbbbbb#bbb#bbbbb###.",
"....aabbbbb#b#bbbb#bbbbb#bbbb#...",
".aaaaabbbbb#b#bbbb#bbbbb#bbbb####",
"....aabbbb#bbb#bb#bbbbbbb#bbb#...",
"..aaaabbbb#bbb###bbbbbbbbb######.",
"....aabbb#bbbbb#bbbbbbbbbbbbb#...",
"..aaaabbb#bbbbb#bbbbbbbbbbbbb###.",
"....aabb#bbbbbbb#bbbbbbbbbbbb#...",
".aaaaa##bbbbbbbbb#####bbbbbbb####",
"....aabbbbbbbbbbbbbbbbbbbbbbb#...",
"..aaaabbbbbbbbbbbbbbbbbbbbbbb###.",
"....aabbbbbbbbbbbbbbbbbbbbbbb#...",
"....aabbbbbbbbbbbbbbbbbbbbbbb#...",
"....aa########################...",
".....#.#.#.#.#.#.#.#.#.#.#.#.....",
".....#.#.#.#.#.#.#.#.#.#.#.#.....",
".........#.....#.....#.....#.....",
".................................",
".................................",
".................................",
"...#............#................",
"...#...........#..#..............",
"...#...........#..#..............",
"...#......###..##.##.............",
"...#.....#...#.#..#..............",
"...#.....#####.#..#..............",
"...#.....#.....#..#..............",
"...#.....#...#.#..#..............",
"...#####..###..#...#............."};

static const char* const image6_data[] = { 
"34 46 4 1",
"a c #000000",
"b c #bfbfbf",
"# c #ff0000",
". c #ffffff",
"..................................",
"..................................",
".........#.....#.....#.....#......",
".....#.#.#.#.#.#.#.#.#.#.#.#......",
".....#.#.#.#.#.#.#.#.#.#.#.#......",
"....##########################....",
"....##########################....",
"..aaabbbbbbbbbbbbbbbbbbbbbbbbaaa..",
"....abbbbbbbbbbbbbbbbbbbbbbbba....",
"..aaabbbbbbbbbbbbbbbbbbbbbbbbaaa..",
"....abbbbbbbbbbbbbbbbbbbbbbbba....",
".aaaabbbbbbbbbbbbbbbbabbbbbbbaaaa.",
"....abbbbbbbbbbbbbbbababbbbbba....",
"..aaabbbbbbbbbbbbbbbababbbbbbaaa..",
"....abbbbbbbbbbbbbbabbbabbbbba....",
"..aaabbbbbbbabbbbbbabbbabbbbbaaa..",
"....abbbbbbababbbbabbbbbabbbba....",
".aaaabbbbbbababbbbabbbbbabbbbaaaa.",
"....abbbbbabbbabbabbbbbbbabbba....",
"..aaabbbbbabbbaaabbbbbbbbbaaaaaa..",
"....abbbbabbbbbabbbbbbbbbbbbba....",
"..aaabbbbabbbbbabbbbbbbbbbbbbaaa..",
"....abbbabbbbbbbabbbbbbbbbbbba....",
".aaaaaaabbbbbbbbbaaaaabbbbbbbaaaa.",
"....abbbbbbbbbbbbbbbbbbbbbbbba....",
"..aaabbbbbbbbbbbbbbbbbbbbbbbbaaa..",
"....abbbbbbbbbbbbbbbbbbbbbbbba....",
"....abbbbbbbbbbbbbbbbbbbbbbbba....",
"....aaaaaaaaaaaaaaaaaaaaaaaaaa....",
".....a.a.a.a.a.a.a.a.a.a.a.a......",
".....a.a.a.a.a.a.a.a.a.a.a.a......",
".........a.....a.....a.....a......",
"..................................",
"..................................",
"..................................",
"...aaaaa..........................",
".....a............................",
".....a............................",
".....a.....aaa..aaaa..............",
".....a....a...a.a...a.............",
".....a....a...a.a...a.............",
".....a....a...a.a...a.............",
".....a....a...a.a...a.............",
".....a.....aaa..aaaa..............",
"................a.................",
"................a................."};

static const char* const image7_data[] = { 
"32 46 4 1",
"# c #000000",
"b c #bfbfbf",
"a c #ff0000",
". c #ffffff",
"................................",
"........#.....#.....#.....#.....",
"....#.#.#.#.#.#.#.#.#.#.#.#.....",
"....#.#.#.#.#.#.#.#.#.#.#.#.....",
"...########################aa...",
"...#bbbbbbbbbbbbbbbbbbbbbbbaa...",
".###bbbbbbbbbbbbbbbbbbbbbbbaaaa.",
"...#bbbbbbbbbbbbbbbbbbbbbbbaa...",
".###bbbbbbbbbbbbbbbbbbbbbbbaaaa.",
"...#bbbbbbbbbbbbbbbbbbbbbbbaa...",
"####bbbbbbbbbbbbbbbb#bbbbbbaaaaa",
"...#bbbbbbbbbbbbbbb#b#bbbbbaa...",
".###bbbbbbbbbbbbbbb#b#bbbbbaaaa.",
"...#bbbbbbbbbbbbbb#bbb#bbbbaa...",
".###bbbbbbb#bbbbbb#bbb#bbbbaaaa.",
"...#bbbbbb#b#bbbb#bbbbb#bbbaa...",
"####bbbbbb#b#bbbb#bbbbb#bbbaaaaa",
"...#bbbbb#bbb#bb#bbbbbbb#bbaa...",
".###bbbbb#bbb###bbbbbbbbb##aaaa.",
"...#bbbb#bbbbb#bbbbbbbbbbbbaa...",
".###bbbb#bbbbb#bbbbbbbbbbbbaaaa.",
"...#bbb#bbbbbbb#bbbbbbbbbbbaa...",
"#######bbbbbbbbb#####bbbbbbaaaaa",
"...#bbbbbbbbbbbbbbbbbbbbbbbaa...",
".###bbbbbbbbbbbbbbbbbbbbbbbaaaa.",
"...#bbbbbbbbbbbbbbbbbbbbbbbaa...",
"...#bbbbbbbbbbbbbbbbbbbbbbbaa...",
"...########################aa...",
"....#.#.#.#.#.#.#.#.#.#.#.#.....",
"....#.#.#.#.#.#.#.#.#.#.#.#.....",
"........#.....#.....#.....#.....",
"................................",
"................................",
"................................",
"..#####...#.......#.............",
"..#....#..........#.....#.......",
"..#....#..........#.....#.......",
"..#....#..#..####.#.##..##......",
"..#####...#.#...#.##..#.#.......",
"..#....#..#.#...#.#...#.#.......",
"..#....#..#.#...#.#...#.#.......",
"..#....#..#.#...#.#...#.#.......",
"..#....#..#..####.#...#..#......",
"................#...............",
"............####................",
"................................"};

#ifndef M_PI
#define M_PI	3.141592653589793238462643 
#endif

genDialog::genDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    QPixmap image4( ( const char** ) image4_data );
    QPixmap image5( ( const char** ) image5_data );
    QPixmap image6( ( const char** ) image6_data );
    QPixmap image7( ( const char** ) image7_data );
    if ( !name )
	setName( "genDialog" );
	setFixedWidth(521);
	setFixedHeight(280);
    setCaption( tr( "QtiPlot - General Plot Options" ) );
    setSizeGripEnabled( FALSE );

    generalDialog = new QTabWidget( this, "generalDialog" );

	initScalesPage();
    initGridPage();
	initAxesPage();
	initFramePage();
	
	GroupBox6 = new QButtonGroup(3,QGroupBox::Horizontal,tr(""),this, "GroupBox6" );
	GroupBox6->setFlat (TRUE);
	GroupBox6->setLineWidth (0);
	
	buttonApply = new QPushButton(GroupBox6, "buttonApply" );
    buttonApply->setText( tr( "&Apply" ) );
	buttonApply->setMaximumWidth(80);
	
    buttonOk = new QPushButton(GroupBox6, "buttonOk" );
    buttonOk->setText( tr( "&OK" ) );
    buttonOk->setDefault( TRUE );
	buttonOk->setMaximumWidth(80);

    buttonCancel = new QPushButton(GroupBox6, "buttonCancel" );
    buttonCancel->setText( tr( "&Cancel" ) );
 	buttonCancel->setMaximumWidth(80);
	
    QVBoxLayout* vlayout = new QVBoxLayout(this,5,5, "vlayout");
	vlayout->addWidget(generalDialog);
    vlayout->addWidget(GroupBox6);

	for (int i=0;i<4;i++)
		titles<<"";

// signals and slots connections
connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
connect( buttonApply, SIGNAL( clicked() ), this, SLOT(updatePlot() ) );
}

void genDialog::initScalesPage()
{
 	scalesPage = new QWidget( generalDialog, "scalesPage" );
	GroupBox1 = new QButtonGroup( 2,QGroupBox::Horizontal,tr( "" ),scalesPage, "GroupBox1" );

	new QLabel(tr( "From" ), GroupBox1, "TextLabel1_3_3",0 );
    boxStart = new QLineEdit( GroupBox1, "boxStart" );
	
    new QLabel(tr( "To" ), GroupBox1, "TextLabel1_3_2_2",0 );
	boxEnd = new QLineEdit( GroupBox1, "boxEnd" );
	
    new QLabel(tr( "Type" ),GroupBox1, "TextLabel2_3_2",0 );
    boxScaleType = new QComboBox( FALSE, GroupBox1, "boxScaleType" );
	boxScaleType->insertItem(tr( "linear" ) );
    boxScaleType->insertItem(tr( "logarithmic" ) );
	
	btnInvert = new QCheckBox( GroupBox1, "btnInvert" );
    btnInvert->setText( tr( "Inverted" ) );
	btnInvert->setChecked(FALSE);
	
	//new QLabel(tr( "Inverted scale" ),GroupBox1, "TextLabel2_3_22", 0);
	
	GroupBox2 = new QButtonGroup( 2,QGroupBox::Horizontal,tr(""),scalesPage, "GroupBox2" );

    btnStep = new QCheckBox( GroupBox2, "btnStep" );
    btnStep->setText( tr( "Step" ) );
	btnStep->setChecked(TRUE);
	
	boxStep = new QLineEdit( GroupBox2, "boxStep" );
	
	btnMinor = new QCheckBox( GroupBox2, "btnMinor" );
    btnMinor->setText( tr( "Major Ticks" ) );
	
	boxMajorValue = new QLineEdit( GroupBox2, "boxMajorValue" );
	boxMajorValue->setDisabled(TRUE);
	
	new QLabel( tr( "Minor Ticks" ),GroupBox2,"TextLabel3_3_2",0 );
	
	boxMinorValue = new QLineEdit( GroupBox2, "boxMinorValue" );
	boxMinorValue->setDisabled(TRUE);

    QPixmap image0( ( const char** ) image0_data );
    QPixmap image1( ( const char** ) image1_data );

    axesList = new QListBox( scalesPage, "axesList" );
    axesList->insertItem( image0, tr( "" ) );
    axesList->insertItem( image1, tr( "" ) );
	axesList->setCurrentItem (0);
	
	QHBoxLayout* hlayout = new QHBoxLayout(scalesPage,5,5, "hlayout");
	hlayout->addWidget(axesList);
    hlayout->addWidget(GroupBox1);
	hlayout->addWidget(GroupBox2);

    generalDialog->insertTab( scalesPage, tr( "Scale" ) );
	
//slots connections
connect(btnInvert,SIGNAL(clicked()), this, SLOT(updatePlot()));
connect(axesList,SIGNAL(highlighted(int) ), this, SLOT(updateScale(int) ) );
connect(btnStep,SIGNAL(clicked() ), this, SLOT(stepEnabled() ) );
connect(btnMinor,SIGNAL(clicked() ), this, SLOT(stepDisabled() ) );	
}

void genDialog::initGridPage()
{
Widget22 = new QWidget( generalDialog, "Widget22" );
	
	GroupBox3 = new QButtonGroup(3,QGroupBox::Horizontal,tr(""),Widget22, "GroupBox3" );

	new QLabel(tr( "" ), GroupBox3, "TextLabel1_400",0 );
	
    boxMajorGrid = new QCheckBox( GroupBox3, "boxMajorGrid" );
    boxMajorGrid->setText( tr( "Major Grids" ) );
	boxMajorGrid->setChecked(TRUE);

    boxMinorGrid = new QCheckBox( GroupBox3, "boxMinorGrid" );
    boxMinorGrid->setText( tr( "Minor Grids" ) );
	boxMinorGrid->setChecked(FALSE);

	new QLabel(tr( "Line Color" ), GroupBox3, "TextLabel1",0 );
	
	boxColorMajor = new QComboBox( FALSE, GroupBox3, "boxColorMajor" );
	boxColorMajor->insertItem( QPixmap(black_xpm), tr( "black" ) );
    boxColorMajor->insertItem( QPixmap(red_xpm), tr( "red" ) );
    boxColorMajor->insertItem( QPixmap(green_xpm), tr( "green" ) );
    boxColorMajor->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	boxColorMajor->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	boxColorMajor->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    boxColorMajor->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	boxColorMajor->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	boxColorMajor->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	boxColorMajor->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	boxColorMajor->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	boxColorMajor->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	boxColorMajor->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	boxColorMajor->insertItem(QPixmap(white_xpm),tr( "white" ) );
	boxColorMajor->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	boxColorMajor->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );

    boxColorMinor = new QComboBox( FALSE, GroupBox3, "boxColorMinor" );
	boxColorMinor->insertItem( QPixmap(black_xpm), tr( "black" ) );
    boxColorMinor->insertItem( QPixmap(red_xpm), tr( "red" ) );
    boxColorMinor->insertItem( QPixmap(green_xpm), tr( "green" ) );
    boxColorMinor->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	boxColorMinor->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	boxColorMinor->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    boxColorMinor->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	boxColorMinor->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	boxColorMinor->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	boxColorMinor->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	boxColorMinor->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	boxColorMinor->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	boxColorMinor->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	boxColorMinor->insertItem(QPixmap(white_xpm),tr( "white" ) );
	boxColorMinor->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	boxColorMinor->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );
	boxColorMinor->setDisabled(TRUE);
	
	new QLabel(tr( "Line Type" ),GroupBox3, "TextLabel1_3",0 ); 
	
	boxTypeMajor = new QComboBox( FALSE, GroupBox3, "boxTypeMajor" );
	boxTypeMajor->insertItem("_____");
	boxTypeMajor->insertItem("- - -");
	boxTypeMajor->insertItem(".....");
	boxTypeMajor->insertItem("_._._");
	boxTypeMajor->insertItem("_.._..");

    boxTypeMinor = new QComboBox( FALSE, GroupBox3, "boxTypeMinor" );
	boxTypeMinor->insertItem("_____");
	boxTypeMinor->insertItem("- - -");
	boxTypeMinor->insertItem(".....");
	boxTypeMinor->insertItem("_._._");
	boxTypeMinor->insertItem("_.._..");
	boxTypeMinor->setDisabled(TRUE);
	
	new QLabel(tr( "Thickness" ), GroupBox3, "TextLabel1_3_2",0 );
	
	boxWidthMajor = new QSpinBox(1,20,1, GroupBox3, "boxWidthMajor" );
	boxWidthMajor->setValue(1);

    boxWidthMinor = new QSpinBox(1,20,1, GroupBox3, "boxWidthMinor" );
	boxWidthMinor->setValue(1);
	boxWidthMinor->setDisabled(TRUE);

	new QLabel(tr( "Aditional lines" ), GroupBox3, "TextLabel1_4",0 );

    boxXLine = new QCheckBox( GroupBox3, "boxXLine" );
    boxXLine->setText( tr( "X=0" ) );
	boxXLine->setDisabled(TRUE);

    boxYLine = new QCheckBox( GroupBox3, "boxYLine" );
    boxYLine->setText( tr( "Y=0" ) );

    QPixmap image2( ( const char** ) image2_data );
    QPixmap image3( ( const char** ) image3_data );

    axesGridList = new QListBox( Widget22, "axesGridList" );
    axesGridList->insertItem( image3, tr( "" ) );
    axesGridList->insertItem( image2, tr( "" ) );
	axesGridList->setCurrentItem(0);
	
	QHBoxLayout* hlayout2 = new QHBoxLayout(Widget22,5,5, "hlayout2");
	hlayout2->addWidget(axesGridList);
    hlayout2->addWidget(GroupBox3);
	
    generalDialog->insertTab( Widget22, tr( "Grid" ) );
	
	//grid page slot connections
connect(axesGridList,SIGNAL(highlighted(int)),this, SLOT(updateLineBoxes(int)));
connect(axesGridList,SIGNAL(selectionChanged()),this, SLOT(setGridOptions()));
connect(boxMajorGrid,SIGNAL(toggled(bool)), this, SLOT(majorGridEnabled(bool)));
connect(boxMinorGrid,SIGNAL(toggled(bool)), this, SLOT(minorGridEnabled(bool)));
connect(boxColorMajor,SIGNAL(activated(int)),this, SLOT(updateGrid(int)));
connect(boxColorMinor,SIGNAL(activated(int)),this, SLOT(updateGrid(int)));
connect(boxTypeMajor,SIGNAL(activated(int)),this, SLOT(updateGrid(int)));
connect(boxTypeMinor,SIGNAL(activated(int)),this, SLOT(updateGrid(int)));
connect(boxWidthMajor,SIGNAL(valueChanged (int)),this, SLOT(updateGrid(int)));
connect(boxWidthMinor,SIGNAL(valueChanged (int)),this, SLOT(updateGrid(int)));
}

void genDialog::initAxesPage()
{
	//axes page
	QPixmap image4( ( const char** ) image4_data );
    QPixmap image5( ( const char** ) image5_data );
    QPixmap image6( ( const char** ) image6_data );
    QPixmap image7( ( const char** ) image7_data );
    tab = new QWidget( generalDialog, "tab" );
	
    axesTitlesList = new QListBox( tab, "axesTitlesList" );
    axesTitlesList->insertItem( image4, tr( "" ) );
    axesTitlesList->insertItem( image5, tr( "" ) );
    axesTitlesList->insertItem( image6, tr( "" ) );
    axesTitlesList->insertItem( image7, tr( "" ) );
	axesTitlesList->setCurrentItem(0);
	axesTitlesList->setMaximumWidth(80);
		
	QVBox  *box=new QVBox (tab, "box2"); 

	QHBox  *hbox1=new QHBox (box, "hbox1"); 
	hbox1->setMargin (5);
	hbox1->setSpacing(5);
	
	new QLabel(tr( "Show" ),hbox1, "TextLabel1_555",0 );

	boxShowAxis = new QCheckBox(hbox1, "boxShowAxis" );
	boxShowAxis->setChecked(TRUE);
	
	new QLabel(tr( "Title" ),hbox1, "TextLabel1_5555",0 );
    boxTitle = new QLineEdit( hbox1, "boxTitle" ); 
	
	new QLabel(tr( "Labels" ),hbox1, "TextLabel1_533",0 );	
	boxShowLabels = new QCheckBox(hbox1, "boxShowLabels" );
	boxShowLabels->setChecked(TRUE);
	
	QHBox  *hbox2=new QHBox (box, "hbox2"); 
	
	QButtonGroup *GroupBox7 = new QButtonGroup(2,QGroupBox::Horizontal,tr(""), hbox2, "GroupBox7" );

	new QLabel(tr( "Type" ),GroupBox7, "TextLabel1_517",0 );	
	boxAxisType= new QComboBox(GroupBox7, "boxAxisType");
	boxAxisType->insertItem(tr("Numeric"));
	boxAxisType->insertItem(tr("Text from datasheet"));
	boxAxisType->insertItem(tr("Day of the week"));
	boxAxisType->insertItem(tr("Month"));

	new QLabel(tr( "Font" ),GroupBox7, "TextLabel1_55",0 );
	btnAxesFont = new QPushButton(GroupBox7, "btnAxesFont" );
    btnAxesFont->setText( tr( "Axis &Font" ) );	

	new QLabel(tr( "Color" ),GroupBox7, "TextLabel1_51",0 );	
	boxAxisColor= new QComboBox(GroupBox7, "boxAxisColor");
	boxAxisColor->insertItem( QPixmap(black_xpm), tr( "black" ) );
    boxAxisColor->insertItem( QPixmap(red_xpm), tr( "red" ) );
    boxAxisColor->insertItem( QPixmap(green_xpm), tr( "green" ) );
    boxAxisColor->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	boxAxisColor->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	boxAxisColor->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    boxAxisColor->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	boxAxisColor->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	boxAxisColor->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	boxAxisColor->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	boxAxisColor->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	boxAxisColor->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	boxAxisColor->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	boxAxisColor->insertItem(QPixmap(white_xpm),tr( "white" ) );
	boxAxisColor->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	boxAxisColor->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );
	
	new QLabel(tr( "Ticks" ), GroupBox7, "TextLabel1_511",0 );	
	boxTicksType= new QComboBox(GroupBox7, "boxAxisColor");
	boxTicksType->insertItem(tr( "In" ) );
	boxTicksType->insertItem(tr( "Out" ) );
	boxTicksType->insertItem(tr( "Both" ) );
	boxTicksType->insertItem(tr( "None" ) );
	
	QButtonGroup *GroupBox8= new QButtonGroup(2,QGroupBox::Horizontal,tr(""), hbox2, "GroupBox8" );
	
	label1 = new QLabel(tr( "Datasheet" ),GroupBox8, "TextLabel1_5131",0 );	
	boxColName= new QComboBox(GroupBox8, "Datasheet");

	label2 = new QLabel(tr( "Format" ),GroupBox8, "TextLabel1_513",0 );	
	boxFormat= new QComboBox(GroupBox8, "boxFormat");
	boxFormat->insertItem(tr( "Automatic" ) );
	boxFormat->insertItem(tr( "Decimal: 100.0" ) );
	boxFormat->insertItem(tr( "Scientific: 1e2" ) );
	boxFormat->insertItem(tr( "Scientific: 10^2" ) );
	
	label3 = new QLabel(tr( "Precision" ),GroupBox8, "TextLabel1_515",0 );		
	boxPrecision= new QSpinBox(0,10,1,GroupBox8, "boxPrecision");
	
	new QLabel(tr( "Angle" ),GroupBox8, "TextLabel1_5151",0 );		
	boxAngle= new QSpinBox(-90,90,5,GroupBox8, "boxAngle");

	QHBox  *hbox4=new QHBox (box, "hbox4"); 
	hbox4->setMargin (5);
	hbox4->setSpacing(5);

	new QLabel(tr( "From" ), hbox4, "TextLabel1_30",0 );
    boxStartAxis = new QLineEdit( hbox4, "boxStart" );
	
    new QLabel(tr( "To" ), hbox4, "TextLabel1_3_20",0 );
	boxEndAxis = new QLineEdit( hbox4, "boxEnd" );
	
	new QLabel(tr( "Step" ), hbox4, "TextLabel1_3_21",0 );
	boxAxisStep = new QLineEdit( hbox4, "boxAxisStep" );
	
	QHBoxLayout* hlayout3 = new QHBoxLayout(tab,5,5, "hlayout3");
	hlayout3->addWidget(axesTitlesList);
    hlayout3->addWidget(box);

	generalDialog->insertTab( tab, tr( "Axis" ) );

//signals and slots connections
connect(generalDialog,SIGNAL(currentChanged ( QWidget * )), this, SLOT(tabPageChanged(QWidget *)));	
connect(axesTitlesList,SIGNAL(highlighted(int)), this, SLOT(updateShowBox(int) ) );	
connect(axesTitlesList,SIGNAL(highlighted(int)), this, SLOT(updateSecondaryScales(int) ) );
connect(axesTitlesList,SIGNAL(highlighted(int)), this, SLOT(updateAxisColor(int)));
connect(axesTitlesList,SIGNAL(highlighted(int) ), this, SLOT(updateTitleBox(int) ) );
connect(axesTitlesList,SIGNAL(highlighted(int) ), this, SLOT(setTicksType(int) ) );
connect(axesTitlesList,SIGNAL(highlighted(int) ), this, SLOT(updateLabelsFormat(int) ) );
connect(axesTitlesList,SIGNAL(highlighted(int) ), this, SLOT(setAxisType(int) ) );

connect(boxShowLabels,SIGNAL(toggled(bool)), this, SLOT(updateTickLabelsList(bool)));
connect(boxAxisColor,SIGNAL(activated(int)), this, SLOT(updateColorsList(int)));
connect(boxTicksType,SIGNAL(activated(int)), this, SLOT(updateTicksType(int)));
connect(boxShowAxis,SIGNAL(clicked()), this, SLOT(showAxis()));
connect(boxFormat,SIGNAL(activated(int) ), this, SLOT(setLabelsFormat(int) ) );
connect(boxPrecision,SIGNAL(valueChanged(int) ), this, SLOT(setLabelsFormat(int)));
connect(boxAxisType,SIGNAL(activated(int) ), this, SLOT(showAxisFormatOptions(int)));
connect( btnAxesFont, SIGNAL( clicked() ), this, SLOT(customAxisFont()) );	
}

void genDialog::initFramePage()
{
frame = new QWidget( generalDialog, "frame" );
	GroupBox5 = new QButtonGroup(2,QGroupBox::Horizontal,tr(""),frame, "GroupBox5" );
	
	boxFramed = new QCheckBox(GroupBox5, "boxFramed" );
    boxFramed->setText( tr( "Draw canvas frame" ) );
	boxFramed->setChecked(TRUE);
	
	new QLabel(tr( "" ),GroupBox5, "TextLabel1_52",0 );
	
	new QLabel(tr( "Frame Color" ),GroupBox5, "TextLabel1_53",0 );
	boxFrameColor= new QComboBox(GroupBox5, "boxFrameColor");
	boxFrameColor->insertItem( QPixmap(black_xpm), tr( "black" ) );
    boxFrameColor->insertItem( QPixmap(red_xpm), tr( "red" ) );
    boxFrameColor->insertItem( QPixmap(green_xpm), tr( "green" ) );
    boxFrameColor->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	boxFrameColor->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	boxFrameColor->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    boxFrameColor->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	boxFrameColor->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	boxFrameColor->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	boxFrameColor->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	boxFrameColor->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	boxFrameColor->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	boxFrameColor->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	boxFrameColor->insertItem(QPixmap(white_xpm),tr( "white" ) );
	boxFrameColor->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	boxFrameColor->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );
	
	new QLabel(tr( "Frame Width" ),GroupBox5, "TextLabel1_54",0 );
	boxFrameWidth= new QSpinBox(GroupBox5, "boxFrameColor");
	boxFrameWidth->setMinValue(1);
	
	QVBoxLayout* hlayout4 = new QVBoxLayout(frame,5,5, "hlayout4");
    hlayout4->addWidget(GroupBox5);
	
	generalDialog->insertTab(frame, tr( "Frame" ) );
	
//frame page slot connections
connect(boxFramed,SIGNAL(toggled(bool)), this, SLOT(drawFrame(bool)));
connect(boxFrameColor,SIGNAL(activated(int)),this, SLOT(updateFrame(int)));
connect(boxFrameWidth,SIGNAL(valueChanged (int)),this, SLOT(updateFrame(int)));
}

void genDialog::showAxisFormatOptions(int format)
{
boxFormat->hide();
boxPrecision->hide();
boxColName->hide();
label1->hide();
label2->hide();
label3->hide();

switch (format)
	{
	case 0:
		label2->show();
		label3->show();
		boxFormat->show();
		boxPrecision->show();
	break;

	case 1:
		label1->show();
		boxColName->show();
	break;

	case 2:
	break;

	case 3:
	break;
	}
}

void genDialog::insertColList(const QStringList& cols)
{
boxColName-> insertStringList(cols);
}

void genDialog::updateAxisType(int)
{
int a=mapToQwtAxisId();
boxAxisType->setCurrentItem(a);
}

void genDialog::setFramed(bool ok)
{
boxFramed->setChecked(ok);
}

void genDialog::setEnabledAxes(QArray<bool> ok)
{
xAxisOn=ok[2];
yAxisOn=ok[0];
topAxisOn=ok[3];
rightAxisOn=ok[1];
}

void genDialog::showAxis()
{
bool ok=boxShowAxis->isChecked();
boxTitle->setEnabled(ok);
boxAxisColor->setEnabled(ok);
btnAxesFont->setEnabled(ok);
boxShowLabels->setEnabled(ok);
boxTicksType->setEnabled(ok);
boxAxisType->setEnabled(ok);

int axis=-1;
int a=axesTitlesList->currentItem();	
switch(a)   
        {
            case 0:
            {
                axis = QwtPlot::xBottom;
				xAxisOn=ok;
                break;
            }
            case 1:
            {
                axis = QwtPlot::yLeft;
				yAxisOn=ok;
                break;
            }
            case 2:
            {
                axis = QwtPlot::xTop;
				topAxisOn=ok;
				
				if (!ok)// reset secondary scales to principal xBottom scale limits
					{
					secondaryScales[0]=	scales[0];
					secondaryScales[1]=	scales[1];
					updateSecondaryScales(a);
					}
                break;
            }
            case 3:
            {
                axis = QwtPlot::yRight;
				rightAxisOn=ok;
				
				if (!ok) // reset secondary scales to principal xBottom scale limits
					{
					secondaryScales[3]=	scales[7];
					secondaryScales[4]=	scales[8];
					updateSecondaryScales(a);
					}
                break;
            }
}

bool labels=FALSE;
if (tickLabelsOn[axis] == "1")
	labels=TRUE;

boxFormat->setEnabled(labels && ok);
boxColName->setEnabled(labels && ok);

if (axis == QwtPlot::xBottom || axis == QwtPlot::xTop)
	boxAngle->setEnabled(labels && ok);
else 
	boxAngle->setDisabled(true);

bool userFormat=TRUE;
if (boxFormat->currentItem() == 2)
	userFormat=FALSE;

boxPrecision->setEnabled(labels && ok && userFormat);

if (a==2 || a==3)
	{
	boxEndAxis->setEnabled(ok);
	boxStartAxis->setEnabled(ok);
	boxAxisStep->setEnabled(ok);
	}
	
emit showAxis(axis,boxAxisType->currentItem(), boxColName->currentText(),ok,ticksType(),boxShowLabels->isChecked(),
			  QColor(axesColors[axis]), boxFormat->currentItem(), boxPrecision->value(), boxAngle->value());
}


void genDialog::drawFrame(bool framed)
{
boxFrameWidth->setEnabled(framed);
boxFrameColor->setEnabled(framed);
	
if (generalDialog->currentPage()==frame)
	emit drawFrame(framed,boxFrameWidth->value(),frameColor());
}

void genDialog::updateFrame(int)
{	
if (generalDialog->currentPage()==frame)
	emit drawFrame(boxFramed->isChecked(), boxFrameWidth->value(),frameColor());
}

void genDialog::setFrameWidth(int w)
{
boxFrameWidth->setValue(w);
}

void genDialog::setFrameColor(const QColor& c)
{
if (c==QColor(black)) boxFrameColor->setCurrentItem(0);
else if (c==QColor(red)) boxFrameColor->setCurrentItem(1);
else if (c==QColor(green)) boxFrameColor->setCurrentItem(2);
else if (c==QColor(blue)) boxFrameColor->setCurrentItem(3);
else if (c==QColor(cyan)) boxFrameColor->setCurrentItem(4);
else if (c==QColor(magenta)) boxFrameColor->setCurrentItem(5);
else if (c==QColor(yellow)) boxFrameColor->setCurrentItem(6);
else if (c==QColor(darkYellow)) boxFrameColor->setCurrentItem(7);
else if (c==QColor(darkBlue)) boxFrameColor->setCurrentItem(8);
else if (c==QColor(darkMagenta)) boxFrameColor->setCurrentItem(9);
else if (c==QColor(darkRed)) boxFrameColor->setCurrentItem(10);
else if (c==QColor(darkGreen)) boxFrameColor->setCurrentItem(11);
else if (c==QColor(darkCyan)) boxFrameColor->setCurrentItem(12);
else if (c==QColor(white)) boxFrameColor->setCurrentItem(13);
else if (c==QColor(lightGray)) boxFrameColor->setCurrentItem(14);
else if (c==QColor(darkGray)) boxFrameColor->setCurrentItem(15);	
}

void genDialog::updateShowBox(int axis)
{
switch(axis)   
        {
        case 0:
            {
				boxShowAxis->setChecked(xAxisOn);
				int labelsOn=tickLabelsOn[2].toInt();
				boxShowLabels->setChecked(labelsOn);
				boxAngle->setEnabled(labelsOn && xAxisOn);
				boxFormat->setEnabled(labelsOn && xAxisOn);
				boxAngle->setValue(xBottomLabelsRotation);
				
				boxEndAxis->setEnabled(FALSE);
				boxAxisStep->setEnabled(FALSE);
				boxStartAxis->setEnabled(FALSE);		
                break;
            }
            case 1:
            {
				boxShowAxis->setChecked(yAxisOn);
				int labelsOn=tickLabelsOn[0].toInt();
				boxShowLabels->setChecked(labelsOn);
				boxFormat->setEnabled(labelsOn && yAxisOn);
                boxAngle->setEnabled(false);
				boxAngle->setValue(0);
				boxEndAxis->setEnabled(FALSE);
				boxAxisStep->setEnabled(FALSE);
				boxStartAxis->setEnabled(FALSE);
                break;
            }
           case 2:
            {
				boxShowAxis->setChecked(topAxisOn);
				
				int labelsOn=tickLabelsOn[3].toInt();
				boxShowLabels->setChecked(labelsOn);
				boxFormat->setEnabled(labelsOn && topAxisOn);
				boxAngle->setEnabled(labelsOn && topAxisOn);
				boxAngle->setValue(xTopLabelsRotation);
				
				boxEndAxis->setEnabled(topAxisOn);
				boxAxisStep->setEnabled(topAxisOn);
				boxStartAxis->setEnabled(topAxisOn);
                break;
            }
            case 3:
            {
				boxShowAxis->setChecked(rightAxisOn);
				int labelsOn=tickLabelsOn[1].toInt();
				boxShowLabels->setChecked(labelsOn );
				boxFormat->setEnabled(labelsOn && rightAxisOn);
                boxAngle->setEnabled(false);
				boxAngle->setValue(0);
				boxEndAxis->setEnabled(rightAxisOn);
				boxAxisStep->setEnabled(rightAxisOn);
				boxStartAxis->setEnabled(rightAxisOn);
                break;
            }
	}

bool ok=boxShowAxis->isChecked();
boxTitle->setEnabled(ok);
boxAxisColor->setEnabled(ok);
btnAxesFont->setEnabled(ok);
boxShowLabels->setEnabled(ok);
boxTicksType->setEnabled(ok);
boxAxisType->setEnabled(ok);	
}

void genDialog::initAxisFonts(const QFont& xB, const QFont& yL, const QFont& xT, const QFont& yR )
{
xBottomFont=xB;
yLeftFont=yL;
xTopFont=xT;
yRightFont=yR;	
}

void genDialog::customAxisFont()
{
bool okF;
int axis=-1;
QFont fnt;
switch(axesTitlesList->currentItem())   
        {
            case 0:
            {
                axis = QwtPlot::xBottom;
				fnt = QFontDialog::getFont( &okF, xBottomFont,this);
				if (okF)
						xBottomFont=fnt;
                break;
            }
            case 1:
            {
                axis = QwtPlot::yLeft;
				fnt = QFontDialog::getFont( &okF, yLeftFont,this);
				if (okF)
						yLeftFont=fnt;
                break;
            }
            case 2:
            {
                axis = QwtPlot::xTop;
				fnt = QFontDialog::getFont( &okF, xTopFont, this);
				if (okF)
						xTopFont=fnt;
                break;
            }
            case 3:
            {
                axis = QwtPlot::yRight;
				fnt = QFontDialog::getFont( &okF, yRightFont, this);
				if (okF)
						yRightFont=fnt;
                break;
            }
		}
		
emit changeAxisFont(axis,fnt);
}

void genDialog::accept()
{
if (updatePlot())
	close();
}

void genDialog::tabPageChanged(QWidget *w)
{
axesTitlesList->clearSelection();
axesList->clearSelection();
axesGridList->clearSelection();

if (w==(QWidget*)tab)
	axesTitlesList->setSelected (0,TRUE);
else if (w==(QWidget*)scalesPage)
	axesList->setSelected (0,TRUE);
else
	axesGridList->setSelected (0,TRUE);
}

void genDialog::updateLineBoxes(int axis)
{
if (axis) 
	{
	boxXLine->setEnabled(TRUE);
	boxYLine->setDisabled(TRUE);
	}
else
	{
	boxXLine->setDisabled(TRUE);
	boxYLine->setEnabled(TRUE);
	}
}

void genDialog::majorGridEnabled(bool on)
{
boxMinorGrid->setEnabled(on);

boxTypeMajor->setEnabled(on);
boxColorMajor->setEnabled(on);
boxWidthMajor->setEnabled(on);

if (generalDialog->currentPage()==Widget22)	
	emit changeGridOptions(getGridOptions());
}

void genDialog::minorGridEnabled(bool on)
{
boxTypeMinor->setEnabled(on);
boxColorMinor->setEnabled(on);
boxWidthMinor->setEnabled(on);

if (generalDialog->currentPage()==Widget22)		
	emit changeGridOptions(getGridOptions());
}

void genDialog::stepEnabled()
{
boxStep->setEnabled(btnStep->isChecked ());
boxMinorValue->setDisabled(btnStep->isChecked ());
boxMajorValue->setDisabled(btnStep->isChecked ());
btnMinor->setChecked(!btnStep->isChecked ());
}

void genDialog::stepDisabled()
{
boxStep->setDisabled(btnMinor->isChecked ());
boxMinorValue->setEnabled(btnMinor->isChecked ());
boxMajorValue->setEnabled(btnMinor->isChecked ());
btnStep->setChecked(!btnMinor->isChecked ());
}

QStringList genDialog::scaleLimits(int axis, double start, double end, double step, 
																const QString& majors, const QString&minors)
{
scales[8*axis+0]=QString::number(start);
scales[8*axis+1]=QString::number(end);
scales[8*axis+2]=QString::number(step);	
scales[8*axis+3]=majors;
scales[8*axis+4]=minors;
scales[8*axis+5]=QString::number(btnStep->isChecked());
scales[8*axis+6]=QString::number(boxScaleType->currentItem());
scales[8*axis+7]=QString::number(btnInvert->isChecked());
return scales;
}

QStringList genDialog::secondaryScaleLimits(int axis)
{
QStringList list;	
if (axis==2 || axis==3)
	{
	secondaryScales[3*(axis-2)+0]=boxStartAxis->text();
	secondaryScales[3*(axis-2)+1]=boxEndAxis->text();
	secondaryScales[3*(axis-2)+2]=boxAxisStep->text();
		
	list<<boxStartAxis->text();
	list<<boxEndAxis->text();
	list<<boxAxisStep->text();
	}
	
return list;
}

void genDialog::setGridOptions()
{
putGridOptions(grid);
}

void genDialog::putGridOptions(gridOptions gr)
{
if (axesGridList->currentItem())
{
boxMajorGrid->setChecked(gr.majorOnX);
boxMinorGrid->setChecked(gr.minorOnX);
}
else
{
boxMajorGrid->setChecked(gr.majorOnY);
boxMinorGrid->setChecked(gr.minorOnY);
}

boxTypeMajor->setCurrentItem(gr.majorStyle);
boxColorMajor->setCurrentItem(gr.majorCol);
boxWidthMajor->setValue(gr.majorWidth);
boxTypeMinor->setCurrentItem(gr.minorStyle);
boxColorMinor->setCurrentItem(gr.minorCol);
boxWidthMinor->setValue(gr.minorWidth);
boxXLine->setChecked(gr.xZeroOn);
boxYLine->setChecked(gr.yZeroOn);

grid =gr;
}

gridOptions genDialog::getGridOptions()
{
if (boxMajorGrid->isChecked() && axesGridList->currentItem())
	grid.majorOnX=1;
else if (!boxMajorGrid->isChecked() && axesGridList->currentItem())
	grid.majorOnX=0;
else if (boxMajorGrid->isChecked() && axesGridList->currentItem()==0)
	grid.majorOnY=1;
else 
	grid.majorOnY=0;

grid.majorStyle=boxTypeMajor->currentItem();
grid.majorCol=boxColorMajor->currentItem();
grid.majorWidth=boxWidthMajor->value();

if (boxMinorGrid->isChecked() && axesGridList->currentItem())
	grid.minorOnX=1;
else if (!boxMinorGrid->isChecked() && axesGridList->currentItem())
	grid.minorOnX=0;
else if (boxMinorGrid->isChecked() && axesGridList->currentItem()==0)
	grid.minorOnY=1;
else 
	grid.minorOnY=0;

grid.minorStyle=boxTypeMinor->currentItem();
grid.minorCol=boxColorMinor->currentItem();
grid.minorWidth=boxWidthMinor->value();

if (boxXLine->isChecked())
	grid.xZeroOn=1;
else grid.xZeroOn=0;

if (boxYLine->isChecked())
	grid.yZeroOn=1;
else grid.yZeroOn=0;

return grid;
}

void genDialog::setAxesColors(const QStringList& colors)
{
axesColors=colors;
}

void genDialog::updateAxisColor(int)
{
int a=mapToQwtAxisId();
setAxisColor(QColor(axesColors[a]));
}

void genDialog::setAxisColor(const QColor& c)
{
if (c==QColor(black)) boxAxisColor->setCurrentItem(0);
else if (c==QColor(red)) boxAxisColor->setCurrentItem(1);
else if (c==QColor(green)) boxAxisColor->setCurrentItem(2);
else if (c==QColor(blue)) boxAxisColor->setCurrentItem(3);
else if (c==QColor(cyan)) boxAxisColor->setCurrentItem(4);
else if (c==QColor(magenta)) boxAxisColor->setCurrentItem(5);
else if (c==QColor(yellow)) boxAxisColor->setCurrentItem(6);
else if (c==QColor(darkYellow)) boxAxisColor->setCurrentItem(7);
else if (c==QColor(darkBlue)) boxAxisColor->setCurrentItem(8);
else if (c==QColor(darkMagenta)) boxAxisColor->setCurrentItem(9);
else if (c==QColor(darkRed)) boxAxisColor->setCurrentItem(10);
else if (c==QColor(darkGreen)) boxAxisColor->setCurrentItem(11);
else if (c==QColor(darkCyan)) boxAxisColor->setCurrentItem(12);
else if (c==QColor(white)) boxAxisColor->setCurrentItem(13);
else if (c==QColor(lightGray)) boxAxisColor->setCurrentItem(14);
else if (c==QColor(darkGray)) boxAxisColor->setCurrentItem(15);	
}

void genDialog::setScaleLimits(const QStringList& limits)
{
scales=limits;
}

bool genDialog::updatePlot()
{
int axis=axesList->currentItem();

if (generalDialog->currentPage()==(QWidget*)scalesPage)
	{
	QString from=boxStart->text();
    QString to=boxEnd->text();
	QString step=boxStep->text();
	QRegExp nonDigit("\\D");
		
	if (boxStart->text().isEmpty())
		{
		QMessageBox::critical(0,"QtiPlot - Input error",
				"Please enter a valid start limit!");
		boxStart->setFocus();
		return FALSE;
		}
		
	if (boxEnd->text().isEmpty())
		{
		QMessageBox::critical(0,"QtiPlot - Input error",
				"Please enter a valid end limit!");
		boxEnd->setFocus();
		return FALSE;
		}
		
	if ( btnStep->isChecked() && boxStep->text().isEmpty())
		{
		QMessageBox::critical(0,"QtiPlot - Input error",
				"Please enter a valid step value!");
		boxStep->setFocus();
		return FALSE;
		}	

	if ( btnMinor->isChecked() && boxMajorValue->text().isEmpty())
		{
		QMessageBox::critical(0,"QtiPlot - Input error",
					"Please enter a non-empty value for the number of major ticks!");
		boxMajorValue->setFocus();
		return FALSE;
		}
		
	if ( btnMinor->isChecked() && boxMajorValue->text().contains(nonDigit) >0)
		{
		QMessageBox::critical(0,"QtiPlot - Input error",
					"Please enter a positive integer value for the number of major ticks!");
		boxMajorValue->setFocus();
		return FALSE;
		}
		
	if ( btnMinor->isChecked() && boxMinorValue->text().isEmpty())
		{
		QMessageBox::critical(0,"QtiPlot - Input error",
				"Please enter a non-empty value for the number of minor ticks!");
		boxMinorValue->setFocus();
		return FALSE;
		}
		
	if ( btnMinor->isChecked() && boxMinorValue->text().contains(nonDigit) >0)
		{
		QMessageBox::critical(0,"QtiPlot - Input error",
					"Please enter a positive  integer value for the number of minor ticks!");
		boxMinorValue->setFocus();
		return FALSE;
		}
		
	from=from.remove(".");
	to=to.remove(".");
	step=step.remove(".");

	int pos=from.find("-",0);
	if(pos==0)
			from=from.replace(pos,1,"");

	pos=to.find("-",0);
	if(pos==0)
		to=to.replace(pos,1,"");
	
	double start,end, stp;
    bool error=FALSE;	
	if (from.contains(nonDigit) >0)
		{
		try
			{
			MathUtils::Parser parser;

			if (from.contains("pi")>0)
				parser.AddConst("pi", M_PI);
			if (from.contains("Pi")>0)
				parser.AddConst("Pi", M_PI);
			if (from.contains("PI")>0)
				parser.AddConst("PI", M_PI);
	
			parser.SetFormula((boxStart->text()).ascii());
			start=parser.Calc();
			}
		catch(MathUtils::ParserException &e)
			{
			QMessageBox::critical(0,"QtiPlot - Start limit error",e.what());
			boxStart->setFocus();
			error=TRUE;
			return FALSE;
			}	
		}
		else
				start=boxStart->text().toDouble();
		
		if (to.contains(nonDigit) >0)
			{
			try
				{
				MathUtils::Parser parser;

				if (to.contains("pi")>0)
						parser.AddConst("pi", M_PI);
				if (to.contains("Pi")>0)
						parser.AddConst("Pi", M_PI);
				if (to.contains("PI")>0)
						parser.AddConst("PI", M_PI);
	
				parser.SetFormula((boxEnd->text()).ascii());
				end=parser.Calc();
				}
			catch(MathUtils::ParserException &e)
				{
				QMessageBox::critical(0,"QtiPlot - End limit error",e.what());
				boxEnd->setFocus();
				error=TRUE;
				return FALSE;
				}	
			}
		else
			end=boxEnd->text().toDouble();
			
		if (step.contains(nonDigit) >0)
		{
		try
			{
			MathUtils::Parser parser;

			if (step.contains("pi")>0)
				parser.AddConst("pi", M_PI);
			if (step.contains("Pi")>0)
				parser.AddConst("Pi", M_PI);
			if (step.contains("PI")>0)
				parser.AddConst("PI", M_PI);
	
			parser.SetFormula((boxStep->text()).ascii());
			stp=parser.Calc();
			}
		catch(MathUtils::ParserException &e)
			{
			QMessageBox::critical(0,"QtiPlot - Step input error",e.what());
			boxStep->setFocus();
			error=TRUE;
			return FALSE;
			}	
		}
		else
				stp=boxStep->text().toDouble();
		
		if (stp <=0)
			{
			QMessageBox::critical(0,"QtiPlot - Step input error","Please enter a positive step value!");
			boxStep->setFocus();
			return FALSE;	
			}
			
		if (!error)
 				emit updatePlotLimits(axis,scaleLimits(axis, start, end, stp, 
														boxMajorValue->text(), boxMinorValue->text()));
	}

if (generalDialog->currentPage()==Widget22)
	emit changeGridOptions(getGridOptions());

if (generalDialog->currentPage()==(QWidget*)tab)
	{	
	axis=mapToQwtAxisId();
	int format = boxAxisType->currentItem();
	axesType[axis] = format;
	QString colName = boxColName->currentText();
	axesLabelsColumns[axis] = colName;

	int at=axesTitlesList->currentItem();
	QString title=boxTitle->text();
	if (titles[at] != title)
		{
		emit updateAxisTitle(at,title);
		titles[at] = title;
		}
		
	if (axis == QwtPlot::xBottom)
		xBottomLabelsRotation=boxAngle->value();
	else if (axis == QwtPlot::xTop)
		xTopLabelsRotation=boxAngle->value();
	
	emit showAxis(axis,format, colName, boxShowAxis->isChecked(),ticksType(), 
				  boxShowLabels->isChecked(),axisColor(), boxFormat->currentItem(), boxPrecision->value(), 
				  boxAngle->value());
		
	if (at==2 || at ==3)
		emit updateSecondaryLimits(at,secondaryScaleLimits(at));	
	}	

if (generalDialog->currentPage()==frame)
	{
	int w=boxFrameWidth->text().toInt();
	emit drawFrame(boxFramed->isChecked(),w,frameColor());
	}
return TRUE;
}

int genDialog::mapToQwtAxisId()
{
int at=axesTitlesList->currentItem();
int axis=-1;
	
switch(at)   
        {
        case 0:
           axis = QwtPlot::xBottom;
        break;

        case 1:
            axis = QwtPlot::yLeft;
        break;

        case 2:
             axis = QwtPlot::xTop;
        break;

        case 3:
             axis = QwtPlot::yRight;
        break;
		}
return axis;
}

void genDialog::setSecondaryScales(const QStringList& limits)
{
secondaryScales=limits;
}

void genDialog::updateSecondaryScales(int axis)
{
if (axis==2 || axis==3)
	{
	boxStartAxis->clear();
	boxEndAxis->clear();
	boxAxisStep->clear();

	boxStartAxis->setText(secondaryScales[3*(axis-2)+0]);
	boxEndAxis->setText(secondaryScales[3*(axis-2)+1]);
	boxAxisStep->setText(secondaryScales[3*(axis-2)+2]);
	}
}

void genDialog::updateScale(int axis)
{
boxStart->clear();
boxEnd->clear();
boxStep->clear();
boxStart->setText(scales[8*axis+0]);
boxEnd->setText(scales[8*axis+1]);
boxStep->setText(scales[8*axis+2]);
boxMajorValue->setText(scales[8*axis+3]);
boxMinorValue->setText(scales[8*axis+4]);

int stepOn=scales[8*axis+5].toInt();
if (stepOn)
	{
	btnStep->setChecked(TRUE);
	boxStep->setEnabled(TRUE);

	btnMinor->setChecked(FALSE);
	boxMajorValue->setEnabled(FALSE);
	boxMinorValue->setEnabled(FALSE);
	}
else
	{
	btnStep->setChecked(FALSE);
	boxStep->setEnabled(FALSE);

	btnMinor->setChecked(TRUE);
	boxMajorValue->setEnabled(TRUE);
	boxMinorValue->setEnabled(TRUE);
	}

int scaleType=scales[8*axis+6].toInt();
boxScaleType->setCurrentItem(scaleType);
	
bool inverted = false;
if (scales[8*axis+7] == "1")
	inverted = true;
btnInvert->setChecked(inverted);
}

void genDialog::updateTitleBox(int axis)
{
QString s=titles[axis];
boxTitle->setText(s);
}

void genDialog::setAxisTitles(QStringList t)
{
titles=t;
}

QColor genDialog::axisColor()
{
QColor c;
switch (boxAxisColor->currentItem())
	{
case 0:
	c=QColor(black);
break;

case 1:
	c=QColor(red);
break;

case 2:
	c=QColor(green);
break;

case 3:
	c=QColor(blue);
break;

case 4:
	c=QColor(cyan);
break;

case 5:
	c=QColor(magenta);
break;

case 6:
	c=QColor(yellow);
break;

case 7:
	c=QColor(darkYellow);
break;

case 8:
	c=QColor(darkBlue);
break;

case 9:
	c=QColor(darkMagenta);
break;

case 10:
	c=QColor(darkRed);
break;

case 11:
	c=QColor(darkGreen);
break;

case 12:
	c=QColor(darkCyan);
break;

case 13:
	c=QColor(white);
break;

case 14:
	c=QColor(lightGray);
break;

case 15:
	c=QColor(darkGray);
break;
	}
return c;
}

QColor genDialog::frameColor()
{
QColor c;
switch (boxFrameColor->currentItem())
	{
case 0:
	c=QColor(black);
break;

case 1:
	c=QColor(red);
break;

case 2:
	c=QColor(green);
break;

case 3:
	c=QColor(blue);
break;

case 4:
	c=QColor(cyan);
break;

case 5:
	c=QColor(magenta);
break;

case 6:
	c=QColor(yellow);
break;

case 7:
	c=QColor(darkYellow);
break;

case 8:
	c=QColor(darkBlue);
break;

case 9:
	c=QColor(darkMagenta);
break;

case 10:
	c=QColor(darkRed);
break;

case 11:
	c=QColor(darkGreen);
break;

case 12:
	c=QColor(darkCyan);
break;

case 13:
	c=QColor(white);
break;

case 14:
	c=QColor(lightGray);
break;

case 15:
	c=QColor(darkGray);
break;
	}
return c;
}

void genDialog::setAxisType(int)
{
int a=mapToQwtAxisId();
int style = axesType[a];
boxAxisType->setCurrentItem(style);
showAxisFormatOptions(style);

if (style == 1)
	boxColName->setCurrentText(axesLabelsColumns[a]);
}

void genDialog::setAxesLabelsColumns(const QStringList& list)
{
axesLabelsColumns=list;
}

void genDialog::setAxesType(const QValueList<int>& list)
{
axesType=list;
}

void genDialog::setTicksType(const QValueList<int>& list)
{
ticks=list;
}

void genDialog::setTicksType(int)
{
int a=mapToQwtAxisId();
switch (ticks[a])
	{
	case -1:
		boxTicksType->setCurrentItem(0);
	break;
	case 0:
		boxTicksType->setCurrentItem(3);
	break;
	case 1:
		boxTicksType->setCurrentItem(1);
	break;
	case 2:
		boxTicksType->setCurrentItem(2);
	break;
	}
}

void genDialog::updateTicksType(int)
{
int axis=mapToQwtAxisId();
int type=ticksType();
if ( ticks[axis] == type)
	return;

ticks[axis]=type;
emit showAxis(axis,boxAxisType->currentItem(), boxColName->currentText(), boxShowAxis->isChecked(), type,
			  boxShowLabels->isChecked(), QColor(axesColors[axis]), boxFormat->currentItem(),boxPrecision->value(), 
			  boxAngle->value());		
}

void genDialog::setEnabledTickLabels(const QStringList& labelsOn)
{
tickLabelsOn=labelsOn;
}

void genDialog::updateTickLabelsList(bool on)
{
boxColName->setEnabled(on);
boxFormat->setEnabled(on);
int axis=mapToQwtAxisId();
if (axis == QwtPlot::xBottom || axis == QwtPlot::xTop)
	boxAngle->setEnabled(on);
	
bool userFormat=TRUE;
if (boxFormat->currentItem() == 2)
	userFormat=FALSE;

boxPrecision->setEnabled(on && userFormat);

if ( tickLabelsOn[axis] == QString::number(on))
	return;
tickLabelsOn[axis]=QString::number(on);

emit showAxis(axis,boxAxisType->currentItem(), boxColName->currentText(), boxShowAxis->isChecked(), ticksType(), 
			  boxShowLabels->isChecked(),QColor(axesColors[axis]), boxFormat->currentItem(), boxPrecision->value(),
			  boxAngle->value());		

int at=axesTitlesList->currentItem();
if (at==2 || at ==3)
		emit updateSecondaryLimits(at,secondaryScaleLimits(at));	
}

void genDialog::updateColorsList(int)
{
int axis=mapToQwtAxisId();
axesColors[axis]=axisColor().name();
emit showAxis(axis,boxAxisType->currentItem(), boxColName->currentText(),boxShowAxis->isChecked(), ticksType(), 
			  boxShowLabels->isChecked(),QColor(axesColors[axis]), boxFormat->currentItem(), boxPrecision->value(), 
			  boxAngle->value());		
}
	
void genDialog::setCurrentScale(int axis)
{
axesList->setCurrentItem (axis);
}

int genDialog::ticksType()
{
int ticks;
switch (boxTicksType->currentItem())
		{
		case 0:
			ticks=-1;
		break;
		case 1:
			ticks=1;
		break;
		case 2:
			ticks=2;
		break;
		case 3:
			ticks=0;
		break;
		}
return ticks;
}

void genDialog::updateGrid(int)
{
if (generalDialog->currentPage()==Widget22)
	emit changeGridOptions(getGridOptions());	
}

void genDialog::setLabelsFormat(const QStringList& list)
{
labelsFormat=list;
}

void genDialog::setLabelsFormat(int)
{
int axis=mapToQwtAxisId();
int format=boxFormat->currentItem();
int prec=boxPrecision->value();
	
if ( labelsFormat[2*axis] ==QString::number(format)
	&& labelsFormat[2*axis+1] ==QString::number(prec))
	return;

if (format == 0)
	boxPrecision->setEnabled(FALSE);
else
	boxPrecision->setEnabled(TRUE);

labelsFormat[2*axis] = QString::number(format);
labelsFormat[2*axis+1] = QString::number(prec);

emit showAxis(axis,boxAxisType->currentItem(), boxColName->currentText(), boxShowAxis->isChecked(), ticksType(),
			  boxShowLabels->isChecked(),QColor(axesColors[axis]), format, prec, boxAngle->value());		
}

void genDialog::updateLabelsFormat(int)
{
int a=mapToQwtAxisId();
	
int format=labelsFormat[2*a].toInt();
boxFormat->setCurrentItem(format);

int prec=labelsFormat[2*a+1].toInt();
boxPrecision->setValue(prec);
	
if (format == 0)
	boxPrecision->setEnabled(FALSE);
else
	boxPrecision->setEnabled(TRUE);
}

void genDialog::initLabelsRotation(int xAngle, int yAngle)
{
xBottomLabelsRotation=xAngle;
xTopLabelsRotation=yAngle;
}

genDialog::~genDialog()
{
}
