#include "lineDlg.h"
#include "colors.h"

#include <qspinbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtabwidget.h>

lineDialog::lineDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "lineDialog" );
	setFixedWidth(282);
	setFixedHeight(144);
    setCaption( tr( "QtiPlot - Line options" ) );

	tw = new QTabWidget( this, "tw" );

	options = new QWidget( tw, "options" );

    GroupBox1 = new QButtonGroup( 2,QGroupBox::Horizontal,tr(""),options,"GroupBox1" );

	new QLabel(tr( "Color" ), GroupBox1, "TextLabel1",0);
	
	colorBox = new QComboBox( FALSE,GroupBox1, "colorBox" );
	colorBox->insertItem( QPixmap(black_xpm), tr( "black" ) );
    colorBox->insertItem( QPixmap(red_xpm), tr( "red" ) );
    colorBox->insertItem( QPixmap(green_xpm), tr( "green" ) );
    colorBox->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	colorBox->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	colorBox->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    colorBox->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	colorBox->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	colorBox->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	colorBox->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	colorBox->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	colorBox->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	colorBox->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	colorBox->insertItem(QPixmap(white_xpm),tr( "white" ) );
	colorBox->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	colorBox->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );
	
	new QLabel(tr( "Line type" ),GroupBox1, "TextLabel1_2_2",0 );

    styleBox = new QComboBox( FALSE, GroupBox1, "styleBox" );
	styleBox->insertItem("_____");
	styleBox->insertItem("- - -");
	styleBox->insertItem(".....");
	styleBox->insertItem("_._._");
	styleBox->insertItem("_.._..");
	
	new QLabel(tr( "Line width" ),GroupBox1, "TextLabel1_2",0 );

    widthBox = new QComboBox( FALSE, GroupBox1, "widthBox" );
	widthBox->insertItem( tr( "1" ) );
    widthBox->insertItem( tr( "2" ) );
    widthBox->insertItem( tr( "3" ) );
    widthBox->insertItem( tr( "4" ) );
    widthBox->insertItem( tr( "5" ) );
	widthBox->setEditable (TRUE);
	widthBox->setCurrentItem(0);
	
	startBox = new QCheckBox(GroupBox1, "startBox" ); 
    startBox->setText( tr( "Arrow at &start" ) );
	
	endBox = new QCheckBox(GroupBox1, "endBox" );
    endBox->setText( tr( "Arrow at &end" ) );
	endBox->setChecked(TRUE);

	QHBoxLayout* hl1 = new QHBoxLayout(options,5,5, "hl1");
    hl1->addWidget(GroupBox1);
	
	tw->insertTab(options, tr( "Opti&ons" ) );
	
	head = new QWidget( tw, "head" );

    QButtonGroup *GroupBox4 = new QButtonGroup( 2,QGroupBox::Horizontal,tr(""),head,"GroupBox4" );

	new QLabel(tr( "Length" ), GroupBox4, "TextLabel111",0);
	boxHeadLength = new QSpinBox( 0,100,1,GroupBox4, "boxHeadLength" );
	
	new QLabel(tr( "Angle" ),GroupBox4, "TextLabel1112",0 );
	boxHeadAngle = new QSpinBox(0,85,5,GroupBox4, "boxHeadAngle" );

	filledBox = new QCheckBox(GroupBox4, "filledBox" ); 
    filledBox->setText( tr( "&Filled" ) );
	
	QHBoxLayout* hl3 = new QHBoxLayout(head,5,5, "hl3");
    hl3->addWidget(GroupBox4);

	tw->insertTab(head, tr( "Arrow &Head" ) );

	geometry = new QWidget( tw, "geometry" );

    QButtonGroup *GroupBox2 = new QButtonGroup( 2,QGroupBox::Horizontal,tr("Start Point"),geometry,"GroupBox2" );

	new QLabel(tr( "X" ), GroupBox2, "TextLabel11",0);
	xStartBox = new QSpinBox( 0,10000,1,GroupBox2, "xstart" );
	
	new QLabel(tr( "Y" ),GroupBox2, "TextLabel111",0 );
	yStartBox = new QSpinBox(0,10000,1,GroupBox2, "ystart" );

	QButtonGroup *GroupBox3 = new QButtonGroup( 2,QGroupBox::Horizontal,tr("End Point"),geometry,"GroupBox3" );

	new QLabel(tr( "X" ), GroupBox3, "TextLabel11",0);
	xEndBox = new QSpinBox(0,10000,1,GroupBox3, "xstart" );
	
	new QLabel(tr( "Y" ),GroupBox3, "TextLabel111",0 );
	yEndBox = new QSpinBox(0,10000,1,GroupBox3, "ystart" );

	QHBoxLayout* hl2 = new QHBoxLayout(geometry,5,5, "hl2");
    hl2->addWidget(GroupBox2);
	hl2->addWidget(GroupBox3);

	tw->insertTab(geometry, tr( "&Geometry" ) );

	GroupBox2 = new QButtonGroup(1,QGroupBox::Horizontal,tr(""),this,"GroupBox2" );
	GroupBox2->setLineWidth (0);
	
    btnOk = new QPushButton(GroupBox2, "btnOk" );
    btnOk->setText( tr( "&Ok" ) );
	
	btnApply = new QPushButton(GroupBox2, "btnApply" );
    btnApply->setText( tr( "&Apply" ) );

    btnCancel = new QPushButton(GroupBox2, "btnCancel" );
    btnCancel->setText( tr( "&Cancel" ) );
	
	QHBoxLayout* hlayout = new QHBoxLayout(this,5,5, "hlayout");
    hlayout->addWidget(tw);
	hlayout->addWidget(GroupBox2);

	connect( btnOk, SIGNAL( clicked() ), this, SLOT(accept() ) );
	connect( btnApply, SIGNAL( clicked() ), this, SLOT(apply() ) );
    connect( btnCancel, SIGNAL( clicked() ), this, SLOT(close() ) );
}

void lineDialog::apply()
{
if (tw->currentPage()==(QWidget *)options)
	{
	Qt::PenStyle style;

	switch (styleBox->currentItem())
		{
		case 0:
			style=Qt::SolidLine;
		break;
		case 1:
			style=Qt::DashLine;
		break;
		case 2:
			style=Qt::DotLine;
		break;
		case 3:
			style=Qt::DashDotLine;
		break;
		case 4:
			style=Qt::DashDotDotLine;
		break;
		}

	emit values(color(),widthBox->currentText().toInt(),style, endBox->isChecked(),startBox->isChecked());
	}
else if (tw->currentPage()==(QWidget *)head)
	{
	emit setHeadGeometry(boxHeadLength->value(),boxHeadAngle->value(), 
		filledBox->isChecked());
	}
else if (tw->currentPage()==(QWidget *)geometry)
	{
	emit setLineGeometry(QPoint(xStartBox->value(),yStartBox->value()),
			QPoint(xEndBox->value(),yEndBox->value()));
	}
enableHeadTab();
}

void lineDialog::accept()
{
apply();
close();
}

void lineDialog::setEndArrow(bool on)
{
endBox->setChecked(on);
}

void lineDialog::setStartArrow(bool on)
{
startBox->setChecked(on);
}

void lineDialog::setStyle(Qt::PenStyle style)
{
if (style==Qt::SolidLine)
	styleBox->setCurrentItem(0);
else if (style==Qt::DashLine)
	styleBox->setCurrentItem(1);
else if (style==Qt::DotLine)
	styleBox->setCurrentItem(2);	
else if (style==Qt::DashDotLine)
	styleBox->setCurrentItem(3);		
else if (style==Qt::DashDotDotLine)
	styleBox->setCurrentItem(4);
}

void lineDialog::setWidth(int w)
{
widthBox->setEditText(QString::number(w));
}

void lineDialog::setColor(QColor c)
{
if (c==QColor(black)) colorBox->setCurrentItem(0);
else if (c==QColor(red)) colorBox->setCurrentItem(1);
else if (c==QColor(green)) colorBox->setCurrentItem(2);
else if (c==QColor(blue)) colorBox->setCurrentItem(3);
else if (c==QColor(cyan)) colorBox->setCurrentItem(4);
else if (c==QColor(magenta)) colorBox->setCurrentItem(5);
else if (c==QColor(yellow)) colorBox->setCurrentItem(6);
else if (c==QColor(darkYellow)) colorBox->setCurrentItem(7);
else if (c==QColor(darkBlue)) colorBox->setCurrentItem(8);
else if (c==QColor(darkMagenta)) colorBox->setCurrentItem(9);
else if (c==QColor(darkRed)) colorBox->setCurrentItem(10);
else if (c==QColor(darkGreen)) colorBox->setCurrentItem(11);
else if (c==QColor(darkCyan)) colorBox->setCurrentItem(12);
else if (c==QColor(white)) colorBox->setCurrentItem(13);
else if (c==QColor(lightGray)) colorBox->setCurrentItem(14);
else if (c==QColor(darkGray)) colorBox->setCurrentItem(15);
}

QColor lineDialog::color()
{
QColor c;
switch (colorBox->currentItem())
	{
case 0:
	c=QColor(black);
break;

case 1:
	c=QColor(red);
break;

case 2:
	c=QColor(green);
break;

case 3:
	c=QColor(blue);
break;

case 4:
	c=QColor(cyan);
break;

case 5:
	c=QColor(magenta);
break;

case 6:
	c=QColor(yellow);
break;

case 7:
	c=QColor(darkYellow);
break;

case 8:
	c=QColor(darkBlue);
break;

case 9:
	c=QColor(darkMagenta);
break;

case 10:
	c=QColor(darkRed);
break;

case 11:
	c=QColor(darkGreen);
break;

case 12:
	c=QColor(darkCyan);
break;

case 13:
	c=QColor(white);
break;

case 14:
	c=QColor(lightGray);
break;

case 15:
	c=QColor(darkGray);
break;
	}
return c;
}

void lineDialog::setStartPoint(const QPoint& p)
{
xStartBox->setValue(p.x());
yStartBox->setValue(p.y());
}

void lineDialog::setEndPoint(const QPoint& p)
{
xEndBox->setValue(p.x());
yEndBox->setValue(p.y());
}

void lineDialog::initHeadGeometry(int length, int angle, bool filled)
{
boxHeadLength->setValue(length);
boxHeadAngle->setValue(angle);
filledBox->setChecked(filled);	
}
	
void lineDialog::enableHeadTab()
{
if (startBox->isChecked() || endBox->isChecked())
	tw->setTabEnabled (head, true);
else
	tw->setTabEnabled (head, false);
}
	
lineDialog::~lineDialog()
{
}
