#include "pieDialog.h"
#include "textDialog.h"
#include "colors.h"

#include <qcheckbox.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qbuttongroup.h>
#include <qpopupmenu.h>
#include <qarray.h>
#include <qinputdialog.h>
#include <qfont.h>
#include <qfontdialog.h> 

#include <qwt_plot.h>

pieDialog::pieDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "pieDialog" );
	setFixedWidth(521);
	setFixedHeight(260);
    setCaption( tr( "QtiPlot - Pie Options" ) );
    setSizeGripEnabled( FALSE );

    generalDialog = new QTabWidget( this, "generalDialog" );
	
	pieOptions = new QWidget( generalDialog, "pieOptions" );
	curvesList = new QListBox(pieOptions, "listBox" );
	
	GroupBox3 = new QButtonGroup(2,QGroupBox::Horizontal,tr( "Border" ),pieOptions, "GroupBox3" );

    new QLabel( tr( "Color" ), GroupBox3, "TextLabel4",0 );

    boxLineColor = new QComboBox( FALSE, GroupBox3, "boxLineColor" );
    boxLineColor->insertItem( QPixmap(black_xpm), tr( "black" ) );
    boxLineColor->insertItem( QPixmap(red_xpm), tr( "red" ) );
    boxLineColor->insertItem( QPixmap(green_xpm), tr( "green" ) );
    boxLineColor->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	boxLineColor->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	boxLineColor->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    boxLineColor->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	boxLineColor->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	boxLineColor->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	boxLineColor->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	boxLineColor->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	boxLineColor->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	boxLineColor->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	boxLineColor->insertItem(QPixmap(white_xpm),tr( "white" ) );
	boxLineColor->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	boxLineColor->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );
	
	new QLabel(tr( "Style" ), GroupBox3, "TextLabel31",0 );  
    boxLineStyle = new QComboBox( FALSE, GroupBox3, "boxLineStyle" );
    boxLineStyle->insertItem("_____");
	boxLineStyle->insertItem("- - -");
	boxLineStyle->insertItem(".....");
	boxLineStyle->insertItem("_._._");
	boxLineStyle->insertItem("_.._..");
	
	new QLabel(tr( "Width" ), GroupBox3, "TextLabel3",0 );  
    boxLineWidth = new QSpinBox( GroupBox3, "boxLineWidth" );
	
	GroupBox2 = new QButtonGroup(2,QGroupBox::Horizontal,tr( "Fill" ),pieOptions, "GroupBox2" );

    new QLabel( tr( "First color" ), GroupBox2, "TextLabel4",0 ); 
    boxFirstColor = new QComboBox( FALSE, GroupBox2, "boxFirstColor" );
    boxFirstColor->insertItem( QPixmap(black_xpm), tr( "black" ) );
    boxFirstColor->insertItem( QPixmap(red_xpm), tr( "red" ) );
    boxFirstColor->insertItem( QPixmap(green_xpm), tr( "green" ) );
    boxFirstColor->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	boxFirstColor->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	boxFirstColor->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    boxFirstColor->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	boxFirstColor->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	boxFirstColor->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	boxFirstColor->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	boxFirstColor->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	boxFirstColor->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	boxFirstColor->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	boxFirstColor->insertItem(QPixmap(white_xpm),tr( "white" ) );
	boxFirstColor->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	boxFirstColor->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );
	
	new QLabel( tr( "Pattern" ), GroupBox2, "TextLabel41",0 );
	boxPattern = new QComboBox( FALSE, GroupBox2, "boxPattern" );
    boxPattern->insertItem(tr( "Solid" ) );
    boxPattern->insertItem(tr( "Horizontal" ) );
    boxPattern->insertItem(tr( "Vertical" ) );
    boxPattern->insertItem(tr( "Cross" ) );
    boxPattern->insertItem(tr( "BDiagonal" ) );
	boxPattern->insertItem(tr( "FDiagonal" ) );
	boxPattern->insertItem(tr( "DiagCross" ) );

	boxPattern->insertItem(tr( "Dense1" ) );
    boxPattern->insertItem(tr( "Dense2" ) );
    boxPattern->insertItem(tr( "Dense3" ) );
    boxPattern->insertItem(tr( "Dense4" ) );
    boxPattern->insertItem(tr( "Dense5" ) );
	boxPattern->insertItem(tr( "Dense6" ) );
	boxPattern->insertItem(tr( "Dense7" ) );
	
	new QLabel(tr( "Pie ray" ), GroupBox2, "rayLabel",0 );  
    boxRay= new QSpinBox(0,2000,10,GroupBox2, "boxRay");
	
	QHBoxLayout* hlayout1 = new QHBoxLayout(pieOptions,5,5, "hlayout1");
	hlayout1->addWidget(curvesList);
    hlayout1->addWidget(GroupBox3);
	hlayout1->addWidget(GroupBox2);
	
	generalDialog->insertTab(pieOptions, tr( "Pie" ) );
	
	frame = new QWidget( generalDialog, "frame" );
	GroupBox5 = new QButtonGroup(2,QGroupBox::Horizontal,tr(""),frame, "GroupBox5" );
	
	boxFramed = new QCheckBox(GroupBox5, "boxFramed" );
    boxFramed->setText( tr( "Draw canvas frame" ) );
	boxFramed->setChecked(TRUE);
	
	new QLabel(tr( "" ),GroupBox5, "TextLabel1_52",0 );
	
	new QLabel(tr( "Color" ),GroupBox5, "TextLabel1_53",0 );
	
	boxFrameColor= new QComboBox(GroupBox5, "boxFrameColor");
	boxFrameColor->insertItem( QPixmap(black_xpm), tr( "black" ) );
    boxFrameColor->insertItem( QPixmap(red_xpm), tr( "red" ) );
    boxFrameColor->insertItem( QPixmap(green_xpm), tr( "green" ) );
    boxFrameColor->insertItem( QPixmap(blue_xpm), tr( "blue" ) );
	boxFrameColor->insertItem( QPixmap(cyan_xpm), tr( "cyan" ) );
	boxFrameColor->insertItem( QPixmap(magenta_xpm), tr( "magenta" ) );
    boxFrameColor->insertItem( QPixmap(yellow_xpm), tr( "yellow" ) );
	boxFrameColor->insertItem( QPixmap(darkYellow_xpm), tr( "dark yellow" ) );
	boxFrameColor->insertItem( QPixmap(darkBlue_xpm), tr( "navy" ) );
	boxFrameColor->insertItem( QPixmap(darkMagenta_xpm), tr( "purple" ) );
	boxFrameColor->insertItem( QPixmap(darkRed_xpm), tr( "wine" ) );
	boxFrameColor->insertItem( QPixmap(darkGreen_xpm), tr( "olive" ) );
	boxFrameColor->insertItem( QPixmap(darkCyan_xpm), tr( "dark cyan" ) );
	boxFrameColor->insertItem(QPixmap(white_xpm),tr( "white" ) );
	boxFrameColor->insertItem( QPixmap(lightGray_xpm), tr( "light gray" ) );
	boxFrameColor->insertItem( QPixmap(darkGray_xpm), tr( "dark gray" ) );
	
	new QLabel(tr( "Width" ),GroupBox5, "TextLabel1_54",0 );
	boxFrameWidth= new QSpinBox(GroupBox5, "boxFrameColor");
	boxFrameWidth->setMinValue(1);
	
	QVBoxLayout* hlayout4 = new QVBoxLayout(frame,5,5, "hlayout4");
    hlayout4->addWidget(GroupBox5);
	
	generalDialog->insertTab(frame, tr( "Frame" ) );
	
	GroupBox1 = new QButtonGroup(4,QGroupBox::Horizontal,tr(""),this, "GroupBox1" );
	GroupBox1->setLineWidth(0);
	GroupBox1->setFlat (TRUE);
	
	buttonWrk = new QPushButton( GroupBox1, "buttonWrk" );
    buttonWrk->setText( tr( "&Worksheet" ) );
	
	buttonApply = new QPushButton( GroupBox1, "buttonApply" );
    buttonApply->setText( tr( "&Apply" ) );
	
    buttonOk = new QPushButton(GroupBox1, "buttonOk" );
    buttonOk->setText( tr( "&OK" ) );
    buttonOk->setDefault( TRUE );
	
    buttonCancel = new QPushButton(GroupBox1, "buttonCancel" );
    buttonCancel->setText( tr( "&Cancel" ) );
	
	QVBoxLayout* vl = new QVBoxLayout(this,5,5, "vl");
	vl->addWidget(generalDialog);
    vl->addWidget(GroupBox1);
   
    // signals and slots connections
	connect( buttonWrk, SIGNAL(clicked()), this, SLOT(showWorksheet()));
	connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
	connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
	connect( buttonApply, SIGNAL( clicked() ), this, SLOT(updatePlot() ) );
	connect(boxFramed,SIGNAL(toggled(bool)), this, SLOT(drawFrame(bool)));
	connect(curvesList, SIGNAL(rightButtonClicked(QListBoxItem *, const QPoint &)), this, SLOT(showPopupMenu(QListBoxItem *, const QPoint &)));
}

void pieDialog::showWorksheet()
{
emit worksheet(curvesList->currentText ());
close();
}

void pieDialog::showPopupMenu(QListBoxItem *, const QPoint &point)
{
QPopupMenu contextMenu(this);
contextMenu.insertItem("&Delete", this, SLOT(removeCurve()));
contextMenu.exec(point);
}

void pieDialog::removeCurve()
{
emit toggleCurve();
curvesList->removeItem (0);
}

void pieDialog::setPieSize(int size)
{
boxRay->setValue(size);
}

void pieDialog::setFramed(bool ok)
{
boxFramed->setChecked(ok);
}

void pieDialog::drawFrame(bool framed)
{
boxFrameWidth->setEnabled(framed);
boxFrameColor->setEnabled(framed);
	
emit drawFrame(framed,boxFrameWidth->text().toInt(),frameColor());
}

void pieDialog::setFrameWidth(int w)
{
boxFrameWidth->setValue(w);
}

void pieDialog::setFrameColor(const QColor& c)
{
if (c==QColor(black)) boxFrameColor->setCurrentItem(0);
else if (c==QColor(red)) boxFrameColor->setCurrentItem(1);
else if (c==QColor(green)) boxFrameColor->setCurrentItem(2);
else if (c==QColor(blue)) boxFrameColor->setCurrentItem(3);
else if (c==QColor(cyan)) boxFrameColor->setCurrentItem(4);
else if (c==QColor(magenta)) boxFrameColor->setCurrentItem(5);
else if (c==QColor(yellow)) boxFrameColor->setCurrentItem(6);
else if (c==QColor(darkYellow)) boxFrameColor->setCurrentItem(7);
else if (c==QColor(darkBlue)) boxFrameColor->setCurrentItem(8);
else if (c==QColor(darkMagenta)) boxFrameColor->setCurrentItem(9);
else if (c==QColor(darkRed)) boxFrameColor->setCurrentItem(10);
else if (c==QColor(darkGreen)) boxFrameColor->setCurrentItem(11);
else if (c==QColor(darkCyan)) boxFrameColor->setCurrentItem(12);
else if (c==QColor(white)) boxFrameColor->setCurrentItem(13);
else if (c==QColor(lightGray)) boxFrameColor->setCurrentItem(14);
else if (c==QColor(darkGray)) boxFrameColor->setCurrentItem(15);	
}

void pieDialog::insertCurveName(const QString& name)
{
curvesList->clear();
curvesList->insertItem(name,-1);
curvesList->setCurrentItem (0);
}

void pieDialog::accept()
{
updatePlot();
close();
}

void pieDialog::updatePlot()
{
if (generalDialog->currentPage()==(QWidget *)pieOptions)
	{
	QPen pen=QPen(borderColor(),boxLineWidth->value(), style());
	emit updatePie(pen, pattern(), boxRay->value(), boxFirstColor->currentItem());	
	}
	
if (generalDialog->currentPage()==(QWidget *)frame)
	emit drawFrame(boxFramed->isChecked(),boxFrameWidth->value(),frameColor());
}

void pieDialog::setBorderWidth(int width)
{
boxLineWidth->setValue(width);
}

void pieDialog::setFirstColor(int c)
{
boxFirstColor->setCurrentItem(c);	
}

void pieDialog::setBorderColor(const QColor& c)
{
if (c==QColor(black)) boxLineColor->setCurrentItem(0);
else if (c==QColor(red)) boxLineColor->setCurrentItem(1);
else if (c==QColor(green)) boxLineColor->setCurrentItem(2);
else if (c==QColor(blue)) boxLineColor->setCurrentItem(3);
else if (c==QColor(cyan)) boxLineColor->setCurrentItem(4);
else if (c==QColor(magenta)) boxLineColor->setCurrentItem(5);
else if (c==QColor(yellow)) boxLineColor->setCurrentItem(6);
else if (c==QColor(darkYellow)) boxLineColor->setCurrentItem(7);
else if (c==QColor(darkBlue)) boxLineColor->setCurrentItem(8);
else if (c==QColor(darkMagenta)) boxLineColor->setCurrentItem(9);
else if (c==QColor(darkRed)) boxLineColor->setCurrentItem(10);
else if (c==QColor(darkGreen)) boxLineColor->setCurrentItem(11);
else if (c==QColor(darkCyan)) boxLineColor->setCurrentItem(12);
else if (c==QColor(white)) boxLineColor->setCurrentItem(13);
else if (c==QColor(lightGray)) boxLineColor->setCurrentItem(14);
else if (c==QColor(darkGray)) boxLineColor->setCurrentItem(15);	
}

QColor pieDialog::borderColor()
{
QColor c;
switch (boxLineColor->currentItem())
	{
case 0:
	c=QColor(black);
break;

case 1:
	c=QColor(red);
break;

case 2:
	c=QColor(green);
break;

case 3:
	c=QColor(blue);
break;

case 4:
	c=QColor(cyan);
break;

case 5:
	c=QColor(magenta);
break;

case 6:
	c=QColor(yellow);
break;

case 7:
	c=QColor(darkYellow);
break;

case 8:
	c=QColor(darkBlue);
break;

case 9:
	c=QColor(darkMagenta);
break;

case 10:
	c=QColor(darkRed);
break;

case 11:
	c=QColor(darkGreen);
break;

case 12:
	c=QColor(darkCyan);
break;

case 13:
	c=QColor(white);
break;

case 14:
	c=QColor(lightGray);
break;

case 15:
	c=QColor(darkGray);
break;
	}
return c;
}

QColor pieDialog::frameColor()
{
QColor c;
switch (boxFrameColor->currentItem())
	{
case 0:
	c=QColor(black);
break;

case 1:
	c=QColor(red);
break;

case 2:
	c=QColor(green);
break;

case 3:
	c=QColor(blue);
break;

case 4:
	c=QColor(cyan);
break;

case 5:
	c=QColor(magenta);
break;

case 6:
	c=QColor(yellow);
break;

case 7:
	c=QColor(darkYellow);
break;

case 8:
	c=QColor(darkBlue);
break;

case 9:
	c=QColor(darkMagenta);
break;

case 10:
	c=QColor(darkRed);
break;

case 11:
	c=QColor(darkGreen);
break;

case 12:
	c=QColor(darkCyan);
break;

case 13:
	c=QColor(white);
break;

case 14:
	c=QColor(lightGray);
break;

case 15:
	c=QColor(darkGray);
break;
	}
return c;
}

Qt::PenStyle pieDialog::style()
{
Qt::PenStyle style;
switch (boxLineStyle->currentItem())
	{
	case 0:
		style=Qt::SolidLine;
	break;
	case 1:
		style=Qt::DashLine;
	break;
	case 2:
		style=Qt::DotLine;
	break;
	case 3:
		style=Qt::DashDotLine;
	break;
	case 4:
		style=Qt::DashDotDotLine;
	break;
	}
return style;
}

void pieDialog::setBorderStyle(const Qt::PenStyle& style)
{
if(style == Qt::SolidLine)
	boxLineStyle->setCurrentItem(0);
if(style == Qt::DashLine)
	boxLineStyle->setCurrentItem(1);
if(style == Qt::DotLine)
	boxLineStyle->setCurrentItem(2);
if(style == Qt::DashDotLine)
	boxLineStyle->setCurrentItem(3);
if(style == Qt::DashDotDotLine)
	boxLineStyle->setCurrentItem(4);
}

void pieDialog::setPattern(const Qt::BrushStyle& style)
{
if (style == Qt::SolidPattern)
	 boxPattern->setCurrentItem(0);
else if (style == Qt::HorPattern)
	 boxPattern->setCurrentItem(1);
else if (style == Qt::VerPattern)
	 boxPattern->setCurrentItem(2);
else if (style == Qt::CrossPattern)
	 boxPattern->setCurrentItem(3);
else if (style == Qt::BDiagPattern)
	 boxPattern->setCurrentItem(4);
else if (style == Qt::FDiagPattern)
	 boxPattern->setCurrentItem(5);
else if (style == Qt::DiagCrossPattern)
	 boxPattern->setCurrentItem(6);
else if (style == Qt::Dense1Pattern)
	 boxPattern->setCurrentItem(7);
else if (style == Qt::Dense2Pattern)
	 boxPattern->setCurrentItem(8);
else if (style == Qt::Dense3Pattern)
	 boxPattern->setCurrentItem(9);
else if (style == Qt::Dense4Pattern)
	 boxPattern->setCurrentItem(10);
else if (style == Qt::Dense5Pattern)
	 boxPattern->setCurrentItem(11);
else if (style == Qt::Dense6Pattern)
	 boxPattern->setCurrentItem(12);
else if (style == Qt::Dense7Pattern)
	 boxPattern->setCurrentItem(13);
}


Qt::BrushStyle pieDialog::pattern()
{
Qt::BrushStyle style;
switch (boxPattern->currentItem())
	{
	case 0:
		style=Qt::SolidPattern;
	break;
	case 1:
		style=Qt::HorPattern;
	break;
	case 2:
		style=Qt::VerPattern;
	break;
	case 3:
		style=Qt::CrossPattern;
	break;
	case 4:
		style=Qt::BDiagPattern;
	break;
	case 5:
		style=Qt::FDiagPattern;
	break;
	case 6:
		style=Qt::DiagCrossPattern;
	break;

	case 7:
		style=Qt::Dense1Pattern;
	break;
	case 8:
		style=Qt::Dense2Pattern;
	break;
	case 9:
		style=Qt::Dense3Pattern;
	break;
	case 10:
		style=Qt::Dense4Pattern;
	break;
	case 11:
		style=Qt::Dense5Pattern;
	break;
	case 12:
		style=Qt::Dense6Pattern;
	break;
	case 13:
		style=Qt::Dense7Pattern;
	break;
	}
return style;
}

pieDialog::~pieDialog()
{
    // no need to delete child widgets, Qt does it all for us
}
