#ifndef PIEDIALOG_H
#define PIEDIALOG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qarray.h>
#include <qstring.h>
 
class QCheckBox;
class QComboBox;
class QLabel;
class QLineEdit;
class QListBox;
class QListBoxItem;
class QPushButton;
class QRadioButton;
class QSpinBox;
class QTabWidget;
class QWidget;
class QStringList;
class QButtonGroup;

class pieDialog : public QDialog
{ 
    Q_OBJECT

public:
    pieDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~pieDialog();

    QPushButton* buttonWrk;
    QPushButton* buttonApply;
    QPushButton* buttonOk;
    QPushButton* buttonCancel;
    QTabWidget* generalDialog;
	QWidget* frame, *pieOptions;

    QListBox *curvesList;
    QSpinBox *boxFrameWidth;
	QSpinBox *boxRay;
	QCheckBox *boxFramed;
	QComboBox *boxFrameColor, *boxLineColor, *boxLineStyle, *boxFirstColor, *boxPattern;
	QButtonGroup *GroupBox1, *GroupBox5, *GroupBox3, *GroupBox2;
	QSpinBox *boxLineWidth;

public slots:
	void accept();
	void updatePlot();
	void drawFrame(bool framed);
	void setFramed(bool ok);
	void setFrameColor(const QColor& c);
	void setFrameWidth(int w);
	QColor frameColor();
	void insertCurveName(const QString& name);
	void showPopupMenu(QListBoxItem *it, const QPoint &point);
	void removeCurve();
	QColor borderColor();
	void setBorderColor(const QColor& c);
	void setBorderWidth(int width);
	void setPieSize(int size);

	void setFirstColor(int c);

	Qt::PenStyle style();
	void setBorderStyle(const Qt::PenStyle& style);
	Qt::BrushStyle pattern();
	void setPattern(const Qt::BrushStyle& style);
	void showWorksheet();

signals:
	void worksheet(const QString&);
	void drawFrame(bool,int,const QColor&);
	void toggleCurve();
	void updatePie(const QPen&, const Qt::BrushStyle &,int, int);
};

#endif // GENDIALOG_H
