#include "rowsDialog.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qbuttongroup.h>
#include <qspinbox.h>
#include <qfont.h>

rowsDialog::rowsDialog( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "rowsDialog" );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 310, 140 ) );
	setMaximumSize( QSize( 310, 140 ) );
    setMouseTracking( TRUE );
    setSizeGripEnabled( FALSE );
	
	QHBox  *box=new QHBox (this, "box"); 
	box->setMargin(5);
	box->setSpacing (5);
	
	GroupBox1 = new QButtonGroup( 2,QGroupBox::Horizontal,tr(""),box,"GroupBox1" );
    new QLabel( tr( "Rows" ), GroupBox1, "TextLabel468",0 );   
	boxRows= new QSpinBox(0,10000,1,GroupBox1, "buttonRows" );
	new QLabel( tr( "Cols" ), GroupBox1, "TextLabel468",0 );  
    boxCols= new QSpinBox(0,10000,1,GroupBox1, "buttonCols" );
	
	GroupBox2 = new QButtonGroup( 2,QGroupBox::Horizontal,tr(""),box,"GroupBox3" );
	new QLabel( tr( "X Column : " ), GroupBox2, "TextLabel468",0 );  
    boxXCol= new QLabel(GroupBox2, "buttonTextFont" );
	
	new QLabel( tr( "Y Column : " ), GroupBox2, "TextLabel468",0 ); 
	boxYCol= new QLabel(GroupBox2, "buttonHeaderFont" );
	
	GroupBox3 = new QButtonGroup( 3,QGroupBox::Horizontal,tr(""),this,"GroupBox3" );
	GroupBox3->setFlat(TRUE);
	GroupBox3->setLineWidth(0);
	
	buttonApply = new QPushButton(GroupBox3, "buttonApply" );
	
	buttonOk = new QPushButton(GroupBox3, "buttonOk" );
    buttonOk->setDefault( TRUE );
   
    buttonCancel = new QPushButton(GroupBox3, "buttonCancel" );
	
	QVBoxLayout* hlayout = new QVBoxLayout(this,5,5, "hlayout");
    hlayout->addWidget(box);
	hlayout->addWidget(GroupBox3);

    languageChange();
   
    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
	connect( buttonApply, SIGNAL( clicked() ), this, SLOT( update() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

rowsDialog::~rowsDialog()
{
}

void rowsDialog::languageChange()
{
    setCaption( tr( "QtiPlot - Set rows and columns" ) );
    buttonOk->setText( tr( "&OK" ) );
	buttonCancel->setText( tr( "&Cancel" ) );
	buttonApply->setText( tr( "&Apply" ) );
}

void rowsDialog::accept()
{
update();
close();
}

void rowsDialog::update()
{
emit updateRows(boxRows->value());
emit updateCols (boxCols->value());
}

void rowsDialog::init(int rows, int cols, const QString& xCol,  const QString& yCol)
{
boxRows->setValue(rows);
boxCols->setValue(cols);
boxXCol->setText(xCol);	
boxYCol->setText(yCol);	
	
QFont fnt=boxXCol->font();
fnt.setBold (true);
	
boxXCol->setFont(fnt);
boxYCol->setFont(fnt);
}
