#ifndef TABLEDIALOG_H
#define TABLEDIALOG_H

#include <qvariant.h>
#include <qdialog.h>

class QPushButton;
class QLineEdit;
class QCheckBox;
class QButtonGroup;
class QComboBox;
class QLabel;

class tableDialog : public QDialog
{
    Q_OBJECT

public:
    tableDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~tableDialog();

    QPushButton* buttonCancel;
    QLineEdit* colName;
    QCheckBox* enumerateAllBox;
    QPushButton* buttonOk;
    QButtonGroup* GroupBox1;
 	QButtonGroup* GroupBox2;
 	QButtonGroup* GroupBox3;
    QCheckBox* applyToRightCols;
    QLineEdit* precisionBox;
    QComboBox* numericBox;
    QComboBox* formatBox;
	QComboBox* displayBox;
    QLineEdit* columnsBox;
    QLineEdit* colWidth;
    QCheckBox* applyToAllBox;
	QLabel *labelNumeric;

protected slots:
    virtual void languageChange();

public slots:
	void setColName(const QString& text);
	void setColWidth(const QString& w);
	void showPrecisionBox(int item);
	void updateFormat();
	void updateFormat(int format);
	void updateNumeric(int numeric);
	void updatePrecision(const QString& text);
	void setPlotDesignation(int i);
	void accept();
	void closeEvent( QCloseEvent *);
	//void updateDisplay(int item);

signals:
	void nameChanged(const QString&);
	void enumRightCols(bool);
	void changeWidth(const QString&, bool);
	void changeFormat(int,int,const QString&,bool);
	void closedTableDialog();
};

#endif // TABLEDIALOG_H
