#ifndef TEXTDIALOG_H
#define TEXTDIALOG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qstring.h>
 
class QLabel;
class QMultiLineEdit;
class QPushButton;
class QComboBox;
class QButtonGroup;
	
class textDialog : public QDialog
{ 
    Q_OBJECT

public:
    textDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~textDialog();

    QPushButton* buttonFont;
    QPushButton* buttonOk;
    QPushButton* buttonCancel;
	QPushButton* buttonApply;
    QLabel* TextLabel1, *TextLabel2;
	QComboBox* boxColor,*alignementBox;

	QPushButton* buttonIndice;
    QPushButton* buttonExp;
    QPushButton* buttonSym;
    QPushButton* buttonB;
    QPushButton* buttonI;
    QPushButton* buttonU;
    QMultiLineEdit* LineEdit;
	QButtonGroup *GroupBox1, *GroupBox2;

public slots:
	
	int alignment();
	void setAlignment(int align);
	void setText(const QString & t);
	QString getText();
	void customFont();
	bool rejected();
	QFont font();
	void setFont(const QFont& fnt);
	QColor color();
	void setColor(QColor c);
	void accept();
	void apply();

	void addIndex();
	void addExp();
	void addSymbol();
	void addUnderline();
	void addItalic();
	void addBold();

signals:
	void changeFont(const QFont &);
	void changeText(const QString &);
	void changeColor(const QColor &);
	void changeAlignment(int);

protected:
	QFont f;
};

#endif // TEXTDIALOG_H
