#ifndef TEXTDLG_H
#define TEXTDLG_H

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QComboBox;
class QLabel;
class QMultiLineEdit;
class QPushButton;
class QButtonGroup;

class textDlg : public QDialog
{ 
    Q_OBJECT

public:
    textDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~textDlg();

    QComboBox* colorBox;
    QPushButton* buttonFont;
    QComboBox* backgroundBox;
    QPushButton* buttonOk;
	QPushButton* buttonApply;
    QComboBox* rotateBox;
    QPushButton* buttonCancel;
    QPushButton* buttonIndice;
    QPushButton* buttonExp;
    QPushButton* buttonSym;
    QPushButton* buttonB;
    QPushButton* buttonI;
    QPushButton* buttonU;
	QPushButton* buttonCurve;
    QMultiLineEdit* LineEdit;
	QButtonGroup *GroupBox1, *GroupBox2;

public slots:
	void setText(const QString & t);
	QString getText();

	void customFont();
	QFont font();
	void setFont(const QFont& fnt);

	QColor color();
	void setColor(QColor c);

	int backgroundType();
	void setBackgroundType(int bkg);

	void setAngle(int angle);
	void accept();
	void apply();

	void addIndex();
	void addExp();
	void addSymbol();
	void addUnderline();
	void addItalic();
	void addBold();
	void addCurve();

signals:
	void values(const QString& text,int,int,const QFont&, const QColor& c);

protected:
	QFont f;
};

#endif // TEXTDLG_H
