#include "valuesDialog.h"
#include "parser/muParser.h"
#include "worksheet.h"

#include <qcombobox.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qmessagebox.h>
#include <qlabel.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qbuttongroup.h>

#ifndef M_PI
#define M_PI	3.141592653589793238462643 
#endif

extern "C" {
double *vector(long nl, long nh);
void free_vector(double *v, long nl, long nh);} 

setColValuesDialog::setColValuesDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "setColValuesDialog" );
 	setMinimumSize( QSize( 410, 190 ) );	
    setCaption( tr( "QtiPlot - Set column values" ) );
    setFocusPolicy( QDialog::StrongFocus );
	
	QHBox  *hbox1=new QHBox (this, "hbox1"); 
	hbox1->setMargin(5);
	hbox1->setSpacing (5);
	
	explain = new QMultiLineEdit(hbox1, "explain" );
    explain->setGeometry( QRect( 10, 10, 150, 80 ) ); 
    explain->setBackgroundOrigin( QMultiLineEdit::WidgetOrigin );
	QPalette pal;
    QColorGroup cg;
    cg.setColor( QColorGroup::Foreground, white );
    cg.setColor( QColorGroup::Button, QColor( 197, 197, 197) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 226, 226, 226) );
    cg.setColor( QColorGroup::Dark, QColor( 98, 98, 98) );
    cg.setColor( QColorGroup::Mid, QColor( 131, 131, 131) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, QColor( 197, 197, 197) );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, white );
    cg.setColor( QColorGroup::Button, QColor( 197, 197, 197) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 226, 226, 226) );
    cg.setColor( QColorGroup::Dark, QColor( 98, 98, 98) );
    cg.setColor( QColorGroup::Mid, QColor( 131, 131, 131) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, QColor( 197, 197, 197) );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 197, 197, 197) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 226, 226, 226) );
    cg.setColor( QColorGroup::Dark, QColor( 98, 98, 98) );
    cg.setColor( QColorGroup::Mid, QColor( 131, 131, 131) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, QColor( 197, 197, 197) );
    cg.setColor( QColorGroup::Background, QColor( 192, 192, 192) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    explain->setPalette( pal );
	
	QVBox  *box2=new QVBox (hbox1, "box2"); 
	box2->setMargin(5);
	box2->setSpacing (5);

	QHBox  *hbox2=new QHBox (box2, "hbox2"); 
	hbox2->setMargin(5);
	hbox2->setSpacing (5);
	
	QLabel  *TextLabel1 = new QLabel(hbox2, "TextLabel1" );
    TextLabel1->setText( tr( "For row (i)" ) );
	
	start = new QLineEdit(hbox2, "start" );
   
    QLabel  *TextLabel2 = new QLabel(hbox2, "TextLabel2" );
    TextLabel2->setText( tr( "to" ) );

    end = new QLineEdit(hbox2, "end" );
  
	GroupBox0 = new QButtonGroup(2,QGroupBox::Horizontal,tr( "" ),box2, "GroupBox0" );
	
    functions = new QComboBox( FALSE, GroupBox0, "functions" );
	
	PushButton3 = new QPushButton(GroupBox0, "PushButton3" );
    PushButton3->setText( tr( "Add function" ) );
    
    ComboBox1 = new QComboBox( FALSE, GroupBox0, "ComboBox1" );
   
    PushButton4 = new QPushButton(GroupBox0, "PushButton4" );
    PushButton4->setText( tr( "Add column" ) );

	QHBox  *hbox3=new QHBox (this, "hbox3"); 
	hbox3->setMargin(5);
	hbox3->setSpacing (5);
	
	commandes = new QMultiLineEdit( hbox3, "commandes" );
    commandes->setGeometry( QRect(10, 100, 260, 70) );
	commandes->setFocus();
	
	QVBox  *box3=new QVBox (hbox3,"box3"); 
	box3->setMargin(5);
	box3->setSpacing (5);
	
    btnOk = new QPushButton(box3, "btnOk" );
    btnOk->setText( tr( "OK" ) );

    btnCancel = new QPushButton( box3, "btnCancel" );
    btnCancel->setText( tr( "Cancel" ) );
	
	QVBoxLayout* layout = new QVBoxLayout(this,5,5, "hlayout3");
    layout->addWidget(hbox1);
	layout->addWidget(hbox3);

setFunctions();
insertExplain();

connect(PushButton3, SIGNAL(clicked()),this, SLOT(insertFunction()));
connect(PushButton4, SIGNAL(clicked()),this, SLOT(insertCol()));
connect(btnOk, SIGNAL(clicked()),this, SLOT(accept()));
connect(btnCancel, SIGNAL(clicked()),this, SLOT(close()));
connect(functions, SIGNAL(activated(int)),this, SLOT(insertExplain()));
}

QSize setColValuesDialog::sizeHint() const 
{
return QSize( 410, 190 );
}

void setColValuesDialog::accept()
{
QString aux=commandes->text();	
aux.remove("\n");
int pos1,pos2,pos3,i;
QStringList variables, rowIndexes, columns, colNames=table->colNames();
int n=aux.contains("col(");
for (i=0;i<n;i++)
	{
	pos1=aux.find("col(",0,TRUE);
	pos2=aux.find("(",pos1+1);
	pos3=aux.find(")",pos2+1);
	
	QString aux2=aux.mid(pos2+1,pos3-pos2-1);
	QStringList items=QStringList::split(",", aux2, FALSE);
	int index=colNames.findIndex (items[0]);	
	if (items.count()  == 2)
		rowIndexes<<items[1];
	else
		rowIndexes<<"i";
			
	QString s="c"+ QString::number(i)+"_"+QString::number(index);
	aux.replace(pos1,4+pos3-pos2,s);
		
	if (variables.contains(s)<=0)
		{
		variables<<s;
		columns<<"col("+aux2+")";
		}
	}
	
int m=(int)variables.count();
double *vars;
vars=vector(0,m-1); 
	
bool error=FALSE;
MathUtils::Parser parser;
try
    {
	for (i=0; i<m; i++)
		{
		parser.AddVar(variables[i].ascii(), &vars[i]);
		if (rowIndexes[i] != "i")	
			{
			MathUtils::Parser rparser;
			double l=0;
			try
    			{	
				rparser.AddVar("i", &l);
				rparser.SetFormula(rowIndexes[i].ascii());
	        	rparser.Calc();
				}
			catch(MathUtils::ParserException &e)
				{
				QMessageBox::critical(0,"QtiPlot - Input function error", e.what());
				error=TRUE;	
				break;
   				}
			}			
		vars[i]=1.0;//dumy value
		}

	if (aux.contains("pi")>0)
		parser.AddConst("pi", M_PI);
	if (aux.contains("Pi")>0)
		parser.AddConst("Pi", M_PI);
	if (aux.contains("PI")>0)
		parser.AddConst("PI", M_PI);

	double index = 1;
	parser.AddVar("i", &index);
	parser.SetFormula(aux.ascii());
	parser.Calc();
	}
catch(MathUtils::ParserException &e)
	{
	if (!error)
		{
		QString errString=e.what();
		for (i=0;i<m;i++)
			errString.replace(variables[i], columns[i], TRUE);

		QMessageBox::critical(0,"QtiPlot - Input function error", errString);
		error=TRUE;	
		}
    }

free_vector(vars,0,m-1);

if (!error)
	{
	emit setValues(commandes->text(), aux, variables, rowIndexes, start->text().toInt(),end->text().toInt());
	close(); 
	}
}

void setColValuesDialog::insertColItem(const QString & text, int index)
{
ComboBox1->insertItem(text,index); 
}

void setColValuesDialog::setEndRow(int index)
{
	start->setText("1");
	end->setText(QString::number(index)); 
}

void setColValuesDialog::setText(const QString& text)
{
commandes->clear();	
commandes->insertAt (text,0,0,FALSE);
}

void setColValuesDialog::setFunctions()
{
functions->insertItem("abs()",0);
functions->insertItem("acos()",1);
functions->insertItem("acosh()",2);
functions->insertItem("asin()",3);
functions->insertItem("asinh()",4);
functions->insertItem("atan()",5);
functions->insertItem("atanh()",6);
functions->insertItem("avg(,)",7);
functions->insertItem("cos()",8);
functions->insertItem("cosh()",9);
functions->insertItem("exp()",10);
functions->insertItem("if( , , )",11);
functions->insertItem("ln()",12);
functions->insertItem("log()",13);
functions->insertItem("log2()",14);
functions->insertItem("min()",15);
functions->insertItem("max()",16);
functions->insertItem("rint()",17);
functions->insertItem("sign()",18);
functions->insertItem("sin()",19);
functions->insertItem("sinh()",20);
functions->insertItem("sqrt()",21);
functions->insertItem("tan()",22);
functions->insertItem("tanh()",23);
}

void setColValuesDialog::insertFunction()
{
QString f=functions->currentText();

int line=0, col=0;
if (commandes->hasMarkedText())
	{	
	f=f.remove(")");
	QString markedText=commandes->markedText ();
	commandes->insert(f+markedText);
	commandes->getCursorPosition (&line,&col);
	commandes->insertAt (")",line,col,FALSE);
	commandes->setCursorPosition (line,col,FALSE);
	}
else
	{	
	commandes->getCursorPosition (&line,&col);
	commandes->insert(f);
	commandes->setCursorPosition (line,col-1+f.length(),FALSE);
	}
}

void setColValuesDialog::insertExplain()
{
QString blabla;
switch (functions->currentItem())
	{
case 0:
	blabla="abs(x):\n Absolute value of x.";
break;

case 1:
	blabla="acos(x):\n Inverse cos function.";
break;

case 2:
	blabla="acosh(x):\n Hyperbolic inverse cos function.";
break;

case 3:
	blabla="asin(x):\n Inverse sin function.";
break;

case 4:
	blabla="asinh(x):\n Hyperbolic inverse sin function.";
break;

case 5:
	blabla="atan(x):\n Inverse tan function.";
break;
case 6:
	blabla="atanh(x):\n  Hyperbolic inverse tan function.";
break;

case 7:
	blabla="avg(x,y,...):\n  Mean value of all arguments.";
break;

case 8:
	blabla="cos (x):\n Calculate cosine.";
break;

case 9:
	blabla="cosh(x):\n Hyperbolic cos function.";
break;

case 10:
	blabla="exp(x):\n e raised to the power of x.";
break;

case 11:
	blabla="if(e1, e2, e3):  	if e1 then e2 else e3.";
break;

case 12:
	blabla="ln(x):\n Calculate natural logarithm.";
break;

case 13:
	blabla="log(x):\n Calculate decimal logarithm.";
break;

case 14:
	blabla="log2(x):\n Calculate 	logarithm to the base 2.";
break;

case 15:
	blabla="min(x,y,...):\n Calculate minimum of all arguments.";
break;
case 16:
	blabla="max(x,y,...):\n Calculate maximum of all arguments.";
break;

case 17:
	blabla="rint(x):\n Round to nearest integer.";
break;

case 18:
	blabla="sign(x):\n Sign function: -1 if x<0; 1 if x>0.";
break;

case 19:
	blabla="sin(x):\n Calculate sine.";
break;

case 20:
	blabla="sinh(x):\n Hyperbolic sin function.";
break;

case 21:
	blabla="sqrt(x):\n Square root function.";
break;

case 22:
	blabla="tan(x):\n 	Calculate tangent function.";
break;

case 23:
	blabla="tanh(x):\n Hyperbolic tan function.";
break;
	}

explain->clear();
explain->insertAt (blabla,0,0,FALSE);
}

void setColValuesDialog::insertCol()
{
QString f=ComboBox1->currentText();
int line, col;
commandes->getCursorPosition (&line,&col);
commandes->insertAt (f,line,col,FALSE); 
commandes->setCursorPosition (line,col+f.length());
}

void setColValuesDialog::setTable(WksheetWindow* w)
{
table=w;
}

setColValuesDialog::~setColValuesDialog()
{
}
